package net.minecraft.client;

import net.minecraft.client.gui.components.Button;
import net.minecraft.client.resources.language.I18n;
import net.minecraft.client.gui.components.OptionButton;
import net.minecraft.client.gui.components.AbstractWidget;
import java.util.function.BiConsumer;
import java.util.function.Predicate;

public class BooleanOption extends Option {
    private final Predicate<Options> getter;
    private final BiConsumer<Options, Boolean> setter;
    
    public BooleanOption(final String string, final Predicate<Options> predicate, final BiConsumer<Options, Boolean> biConsumer) {
        super(string);
        this.getter = predicate;
        this.setter = biConsumer;
    }
    
    public void set(final Options dbp, final String string) {
        this.set(dbp, "true".equals(string));
    }
    
    public void toggle(final Options dbp) {
        this.set(dbp, !this.get(dbp));
        dbp.save();
    }
    
    private void set(final Options dbp, final boolean boolean2) {
        this.setter.accept(dbp, boolean2);
    }
    
    public boolean get(final Options dbp) {
        return this.getter.test(dbp);
    }
    
    @Override
    public AbstractWidget createButton(final Options dbp, final int integer2, final int integer3, final int integer4) {
        return new OptionButton(integer2, integer3, integer4, 20, this, this.getMessage(dbp), dct -> {
            this.toggle(dbp);
            dct.setMessage(this.getMessage(dbp));
        });
    }
    
    public String getMessage(final Options dbp) {
        return this.getCaption() + I18n.get(this.get(dbp) ? "options.on" : "options.off");
    }
}
