package net.minecraft.client;

import net.minecraft.client.resources.language.I18n;
import com.mojang.blaze3d.platform.VideoMode;
import java.util.Optional;
import javax.annotation.Nullable;
import com.mojang.blaze3d.platform.Monitor;
import com.mojang.blaze3d.platform.Window;

public class FullscreenResolutionProgressOption extends ProgressOption {
    public FullscreenResolutionProgressOption(final Window cxu) {
        this(cxu, cxu.findBestMonitor());
    }
    
    private FullscreenResolutionProgressOption(final Window cxu, @Nullable final Monitor cxm) {
        Optional<VideoMode> optional4;
        double double5;
        String string6;
        super("options.fullscreen.resolution", -1.0, (cxm != null) ? ((double)(cxm.getModeCount() - 1)) : -1.0, 1.0f, dbp -> {
            if (cxm == null) {
                return Double.valueOf(-1.0);
            }
            else {
                optional4 = cxu.getPreferredFullscreenVideoMode();
                return Double.valueOf(optional4.map(cxt -> Double.valueOf(cxm.getVideoModeIndex(cxt))).orElse(-1.0));
            }
        }, (dbp, double4) -> {
            if (cxm != null) {
                if (double4 == -1.0) {
                    cxu.setPreferredFullscreenVideoMode(Optional.<VideoMode>empty());
                }
                else {
                    cxu.setPreferredFullscreenVideoMode(Optional.<VideoMode>of(cxm.getMode(double4.intValue())));
                }
            }
        }, (dbp, dbr) -> {
            if (cxm == null) {
                return I18n.get("options.fullscreen.unavailable");
            }
            else {
                double5 = dbr.get(dbp);
                string6 = dbr.getCaption();
                if (double5 == -1.0) {
                    return string6 + I18n.get("options.fullscreen.current");
                }
                else {
                    return cxm.getMode((int)double5).toString();
                }
            }
        });
    }
}
