package net.minecraft.client;

import net.minecraft.client.multiplayer.PlayerInfo;
import net.minecraft.client.multiplayer.ClientPacketListener;
import net.minecraft.client.player.LocalPlayer;
import net.minecraft.client.multiplayer.ClientLevel;
import java.util.UUID;
import com.mojang.bridge.game.GameSession;

public class Session implements GameSession {
    private final int players;
    private final boolean isRemoteServer;
    private final String difficulty;
    private final String gameMode;
    private final UUID id;
    
    public Session(final ClientLevel dnl, final LocalPlayer dpy, final ClientPacketListener dnm) {
        this.players = dnm.getOnlinePlayers().size();
        this.isRemoteServer = !dnm.getConnection().isMemoryConnection();
        this.difficulty = dnl.getDifficulty().getKey();
        final PlayerInfo dnp5 = dnm.getPlayerInfo(dpy.getUUID());
        if (dnp5 != null) {
            this.gameMode = dnp5.getGameMode().getName();
        }
        else {
            this.gameMode = "unknown";
        }
        this.id = dnm.getId();
    }
    
    public int getPlayerCount() {
        return this.players;
    }
    
    public boolean isRemoteServer() {
        return this.isRemoteServer;
    }
    
    public String getDifficulty() {
        return this.difficulty;
    }
    
    public String getGameMode() {
        return this.gameMode;
    }
    
    public UUID getSessionId() {
        return this.id;
    }
}
