package net.minecraft.client.gui.components;

import net.minecraft.client.gui.components.events.GuiEventListener;
import com.google.common.collect.ImmutableList;
import net.minecraft.client.Options;
import java.util.List;
import javax.annotation.Nullable;
import net.minecraft.client.Option;
import net.minecraft.client.Minecraft;

public class OptionsList extends ContainerObjectSelectionList<Entry> {
    public OptionsList(final Minecraft dbl, final int integer2, final int integer3, final int integer4, final int integer5, final int integer6) {
        super(dbl, integer2, integer3, integer4, integer5, integer6);
        this.centerListVertically = false;
    }
    
    public int addBig(final Option dbo) {
        return this.addEntry(Entry.big(this.minecraft.options, this.width, dbo));
    }
    
    public void addSmall(final Option dbo1, @Nullable final Option dbo2) {
        this.addEntry(Entry.small(this.minecraft.options, this.width, dbo1, dbo2));
    }
    
    public void addSmall(final Option[] arr) {
        for (int integer3 = 0; integer3 < arr.length; integer3 += 2) {
            this.addSmall(arr[integer3], (integer3 < arr.length - 1) ? arr[integer3 + 1] : null);
        }
    }
    
    @Override
    public int getRowWidth() {
        return 400;
    }
    
    @Override
    protected int getScrollbarPosition() {
        return super.getScrollbarPosition() + 32;
    }
    
    public static class Entry extends ContainerObjectSelectionList.Entry<Entry> {
        private final List<AbstractWidget> children;
        
        private Entry(final List<AbstractWidget> list) {
            this.children = list;
        }
        
        public static Entry big(final Options dbp, final int integer, final Option dbo) {
            return new Entry(ImmutableList.<AbstractWidget>of(dbo.createButton(dbp, integer / 2 - 155, 0, 310)));
        }
        
        public static Entry small(final Options dbp, final int integer, final Option dbo3, @Nullable final Option dbo4) {
            final AbstractWidget dcr5 = dbo3.createButton(dbp, integer / 2 - 155, 0, 150);
            if (dbo4 == null) {
                return new Entry(ImmutableList.<AbstractWidget>of(dcr5));
            }
            return new Entry(ImmutableList.<AbstractWidget>of(dcr5, dbo4.createButton(dbp, integer / 2 - 155 + 160, 0, 150)));
        }
        
        @Override
        public void render(final int integer1, final int integer2, final int integer3, final int integer4, final int integer5, final int integer6, final int integer7, final boolean boolean8, final float float9) {
            this.children.forEach(dcr -> {
                dcr.y = integer2;
                dcr.render(integer6, integer7, float9);
            });
        }
        
        @Override
        public List<? extends GuiEventListener> children() {
            return this.children;
        }
    }
}
