package net.minecraft.client.gui.components.toasts;

import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.client.resources.language.I18n;
import com.mojang.blaze3d.systems.RenderSystem;
import com.google.common.collect.Lists;
import net.minecraft.world.item.crafting.Recipe;
import java.util.List;

public class RecipeToast implements Toast {
    private final List<Recipe<?>> recipes;
    private long lastChanged;
    private boolean changed;
    
    public RecipeToast(final Recipe<?> bgt) {
        (this.recipes = Lists.newArrayList()).add(bgt);
    }
    
    @Override
    public Visibility render(final ToastComponent ddz, final long long2) {
        if (this.changed) {
            this.lastChanged = long2;
            this.changed = false;
        }
        if (this.recipes.isEmpty()) {
            return Visibility.HIDE;
        }
        ddz.getMinecraft().getTextureManager().bind(RecipeToast.TEXTURE);
        RenderSystem.color3f(1.0f, 1.0f, 1.0f);
        ddz.blit(0, 0, 0, 32, 160, 32);
        ddz.getMinecraft().font.draw(I18n.get("recipe.toast.title"), 30.0f, 7.0f, -11534256);
        ddz.getMinecraft().font.draw(I18n.get("recipe.toast.description"), 30.0f, 18.0f, -16777216);
        final Recipe<?> bgt5 = this.recipes.get((int)(long2 / (5000L / this.recipes.size()) % this.recipes.size()));
        final ItemStack bek6 = bgt5.getToastSymbol();
        RenderSystem.pushMatrix();
        RenderSystem.scalef(0.6f, 0.6f, 1.0f);
        ddz.getMinecraft().getItemRenderer().renderAndDecorateItem(null, bek6, 3, 3);
        RenderSystem.popMatrix();
        ddz.getMinecraft().getItemRenderer().renderAndDecorateItem(null, bgt5.getResultItem(), 8, 8);
        return (long2 - this.lastChanged >= 5000L) ? Visibility.HIDE : Visibility.SHOW;
    }
    
    public void addItem(final Recipe<?> bgt) {
        if (this.recipes.add(bgt)) {
            this.changed = true;
        }
    }
    
    public static void addOrUpdate(final ToastComponent ddz, final Recipe<?> bgt) {
        final RecipeToast ddw3 = ddz.<RecipeToast>getToast(RecipeToast.class, RecipeToast.NO_TOKEN);
        if (ddw3 == null) {
            ddz.addToast(new RecipeToast(bgt));
        }
        else {
            ddw3.addItem(bgt);
        }
    }
}
