package net.minecraft.client.gui.screens;

import net.minecraft.client.gui.components.Button;
import net.minecraft.client.resources.language.I18n;
import net.minecraft.client.gui.chat.NarratorChatListener;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.TranslatableComponent;
import net.minecraft.client.Options;
import net.minecraft.client.gui.components.AbstractWidget;
import net.minecraft.client.Option;

public class AccessibilityOptionsScreen extends OptionsSubScreen {
    private static final Option[] OPTIONS;
    private AbstractWidget narratorButton;
    
    public AccessibilityOptionsScreen(final Screen dfz, final Options dbp) {
        super(dfz, dbp, new TranslatableComponent("options.accessibility.title", new Object[0]));
    }
    
    @Override
    protected void init() {
        int integer2 = 0;
        for (final Option dbo6 : AccessibilityOptionsScreen.OPTIONS) {
            final int integer3 = this.width / 2 - 155 + integer2 % 2 * 160;
            final int integer4 = this.height / 6 + 24 * (integer2 >> 1);
            final AbstractWidget dcr9 = this.<AbstractWidget>addButton(dbo6.createButton(this.minecraft.options, integer3, integer4, 150));
            if (dbo6 == Option.NARRATOR) {
                this.narratorButton = dcr9;
                dcr9.active = NarratorChatListener.INSTANCE.isActive();
            }
            ++integer2;
        }
        this.<Button>addButton(new Button(this.width / 2 - 100, this.height / 6 + 144, 200, 20, I18n.get("gui.done"), dct -> this.minecraft.setScreen(this.lastScreen)));
    }
    
    @Override
    public void render(final int integer1, final int integer2, final float float3) {
        this.renderBackground();
        this.drawCenteredString(this.font, this.title.getColoredString(), this.width / 2, 20, 16777215);
        super.render(integer1, integer2, float3);
    }
    
    public void updateNarratorButton() {
        this.narratorButton.setMessage(Option.NARRATOR.getMessage(this.options));
    }
    
    static {
        OPTIONS = new Option[] { Option.NARRATOR, Option.SHOW_SUBTITLES, Option.TEXT_BACKGROUND_OPACITY, Option.TEXT_BACKGROUND, Option.CHAT_OPACITY, Option.AUTO_JUMP, Option.TOGGLE_CROUCH, Option.TOGGLE_SPRINT };
    }
}
