package net.minecraft.client.model;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.world.entity.Entity;

public abstract class ColorableAgeableListModel<E extends Entity> extends AgeableListModel<E> {
    private float r;
    private float g;
    private float b;
    
    public ColorableAgeableListModel() {
        this.r = 1.0f;
        this.g = 1.0f;
        this.b = 1.0f;
    }
    
    public void setColor(final float float1, final float float2, final float float3) {
        this.r = float1;
        this.g = float2;
        this.b = float3;
    }
    
    @Override
    public void renderToBuffer(final PoseStack cyi, final VertexConsumer cyl, final int integer3, final int integer4, final float float5, final float float6, final float float7, final float float8) {
        super.renderToBuffer(cyi, cyl, integer3, integer4, this.r * float5, this.g * float6, this.b * float7, float8);
    }
}
