package net.minecraft.client.model;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.resources.ResourceLocation;

public class TridentModel extends Model {
    public static final ResourceLocation TEXTURE;
    private final ModelPart pole;
    
    public TridentModel() {
        super(RenderType::entitySolid);
        (this.pole = new ModelPart(32, 32, 0, 6)).addBox(-0.5f, 2.0f, -0.5f, 1.0f, 25.0f, 1.0f, 0.0f);
        final ModelPart dnf2 = new ModelPart(32, 32, 4, 0);
        dnf2.addBox(-1.5f, 0.0f, -0.5f, 3.0f, 2.0f, 1.0f);
        this.pole.addChild(dnf2);
        final ModelPart dnf3 = new ModelPart(32, 32, 4, 3);
        dnf3.addBox(-2.5f, -3.0f, -0.5f, 1.0f, 4.0f, 1.0f);
        this.pole.addChild(dnf3);
        final ModelPart dnf4 = new ModelPart(32, 32, 0, 0);
        dnf4.addBox(-0.5f, -4.0f, -0.5f, 1.0f, 4.0f, 1.0f, 0.0f);
        this.pole.addChild(dnf4);
        final ModelPart dnf5 = new ModelPart(32, 32, 4, 3);
        dnf5.mirror = true;
        dnf5.addBox(1.5f, -3.0f, -0.5f, 1.0f, 4.0f, 1.0f);
        this.pole.addChild(dnf5);
    }
    
    @Override
    public void renderToBuffer(final PoseStack cyi, final VertexConsumer cyl, final int integer3, final int integer4, final float float5, final float float6, final float float7, final float float8) {
        this.pole.render(cyi, cyl, integer3, integer4, float5, float6, float7, float8);
    }
    
    static {
        TEXTURE = new ResourceLocation("textures/entity/trident.png");
    }
}
