package net.minecraft.client.particle;

import net.minecraft.core.particles.ParticleOptions;
import net.minecraft.core.particles.SimpleParticleType;
import net.minecraft.world.level.Level;

public class EndRodParticle extends SimpleAnimatedParticle {
    private EndRodParticle(final Level bjt, final double double2, final double double3, final double double4, final double double5, final double double6, final double double7, final SpriteSet dpj) {
        super(bjt, double2, double3, double4, dpj, -5.0E-4f);
        this.xd = double5;
        this.yd = double6;
        this.zd = double7;
        this.quadSize *= 0.75f;
        this.lifetime = 60 + this.random.nextInt(12);
        this.setFadeColor(15916745);
        this.setSpriteFromAge(dpj);
    }
    
    @Override
    public void move(final double double1, final double double2, final double double3) {
        this.setBoundingBox(this.getBoundingBox().move(double1, double2, double3));
        this.setLocationFromBoundingbox();
    }
    
    public static class Provider implements ParticleProvider<SimpleParticleType> {
        private final SpriteSet sprites;
        
        public Provider(final SpriteSet dpj) {
            this.sprites = dpj;
        }
        
        @Override
        public Particle createParticle(final SimpleParticleType gw, final Level bjt, final double double3, final double double4, final double double5, final double double6, final double double7, final double double8) {
            return new EndRodParticle(bjt, double3, double4, double5, double6, double7, double8, this.sprites, null);
        }
    }
}
