package net.minecraft.client.particle;

import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.util.Mth;
import net.minecraft.client.Camera;
import com.mojang.blaze3d.vertex.VertexConsumer;
import net.minecraft.world.phys.Vec3;
import net.minecraft.world.level.Level;
import net.minecraft.client.renderer.entity.EntityRenderDispatcher;
import net.minecraft.world.entity.Entity;
import net.minecraft.client.renderer.RenderBuffers;

public class ItemPickupParticle extends Particle {
    private final RenderBuffers renderBuffers;
    private final Entity itemEntity;
    private final Entity target;
    private int life;
    private final EntityRenderDispatcher entityRenderDispatcher;
    
    public ItemPickupParticle(final EntityRenderDispatcher dvc, final RenderBuffers dqw, final Level bjt, final Entity akn4, final Entity akn5) {
        this(dvc, dqw, bjt, akn4, akn5, akn4.getDeltaMovement());
    }
    
    private ItemPickupParticle(final EntityRenderDispatcher dvc, final RenderBuffers dqw, final Level bjt, final Entity akn4, final Entity akn5, final Vec3 cvi) {
        super(bjt, akn4.getX(), akn4.getY(), akn4.getZ(), cvi.x, cvi.y, cvi.z);
        this.renderBuffers = dqw;
        this.itemEntity = akn4;
        this.target = akn5;
        this.entityRenderDispatcher = dvc;
    }
    
    @Override
    public ParticleRenderType getRenderType() {
        return ParticleRenderType.CUSTOM;
    }
    
    @Override
    public void render(final VertexConsumer cyl, final Camera daz, final float float3) {
        float float4 = (this.life + float3) / 3.0f;
        float4 *= float4;
        final double double6 = Mth.lerp(float3, this.target.xOld, this.target.getX());
        final double double7 = Mth.lerp(float3, this.target.yOld, this.target.getY()) + 0.5;
        final double double8 = Mth.lerp(float3, this.target.zOld, this.target.getZ());
        final double double9 = Mth.lerp(float4, this.itemEntity.getX(), double6);
        final double double10 = Mth.lerp(float4, this.itemEntity.getY(), double7);
        final double double11 = Mth.lerp(float4, this.itemEntity.getZ(), double8);
        final MultiBufferSource.BufferSource a18 = this.renderBuffers.bufferSource();
        final Vec3 cvi19 = daz.getPosition();
        this.entityRenderDispatcher.<Entity>render(this.itemEntity, double9 - cvi19.x(), double10 - cvi19.y(), double11 - cvi19.z(), this.itemEntity.yRot, float3, new PoseStack(), a18, this.entityRenderDispatcher.<Entity>getPackedLightCoords(this.itemEntity, float3));
        a18.endBatch();
    }
    
    @Override
    public void tick() {
        ++this.life;
        if (this.life == 3) {
            this.remove();
        }
    }
}
