package net.minecraft.client.renderer.blockentity;

import net.minecraft.world.level.block.entity.BlockEntity;
import com.mojang.blaze3d.vertex.VertexConsumer;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.client.renderer.RenderType;
import com.mojang.math.Vector3f;
import net.minecraft.core.Direction;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.level.block.LecternBlock;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.model.BookModel;
import net.minecraft.world.level.block.entity.LecternBlockEntity;

public class LecternRenderer extends BlockEntityRenderer<LecternBlockEntity> {
    private final BookModel bookModel;
    
    public LecternRenderer(final BlockEntityRenderDispatcher dsn) {
        super(dsn);
        this.bookModel = new BookModel();
    }
    
    @Override
    public void render(final LecternBlockEntity bxa, final float float2, final PoseStack cyi, final MultiBufferSource dqq, final int integer5, final int integer6) {
        final BlockState byg8 = bxa.getBlockState();
        if (!byg8.<Boolean>getValue((Property<Boolean>)LecternBlock.HAS_BOOK)) {
            return;
        }
        cyi.pushPose();
        cyi.translate(0.5, 1.0625, 0.5);
        final float float3 = byg8.<Direction>getValue((Property<Direction>)LecternBlock.FACING).getClockWise().toYRot();
        cyi.mulPose(Vector3f.YP.rotationDegrees(-float3));
        cyi.mulPose(Vector3f.ZP.rotationDegrees(67.5f));
        cyi.translate(0.0, -0.125, 0.0);
        this.bookModel.setupAnim(0.0f, 0.1f, 0.9f, 1.2f);
        final VertexConsumer cyl10 = EnchantTableRenderer.BOOK_LOCATION.buffer(dqq, RenderType::entitySolid);
        this.bookModel.render(cyi, cyl10, integer5, integer6, 1.0f, 1.0f, 1.0f, 1.0f);
        cyi.popPose();
    }
}
