package net.minecraft.client.renderer.blockentity;

import net.minecraft.world.level.block.state.AbstractStateHolder;
import net.minecraft.world.level.block.entity.BlockEntity;
import com.mojang.blaze3d.vertex.VertexConsumer;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.world.level.BlockAndTintGetter;
import java.util.Random;
import net.minecraft.client.renderer.ItemBlockRenderTypes;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.piston.PistonBaseBlock;
import net.minecraft.world.level.block.state.properties.PistonType;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.level.block.piston.PistonHeadBlock;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.client.renderer.block.ModelBlockRenderer;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.block.BlockRenderDispatcher;
import net.minecraft.world.level.block.piston.PistonMovingBlockEntity;

public class PistonHeadRenderer extends BlockEntityRenderer<PistonMovingBlockEntity> {
    private final BlockRenderDispatcher blockRenderer;
    
    public PistonHeadRenderer(final BlockEntityRenderDispatcher dsn) {
        super(dsn);
        this.blockRenderer = Minecraft.getInstance().getBlockRenderer();
    }
    
    @Override
    public void render(final PistonMovingBlockEntity byc, final float float2, final PoseStack cyi, final MultiBufferSource dqq, final int integer5, final int integer6) {
        final Level bjt8 = byc.getLevel();
        if (bjt8 == null) {
            return;
        }
        final BlockPos fk9 = byc.getBlockPos().relative(byc.getMovementDirection().getOpposite());
        BlockState byg10 = byc.getMovedState();
        if (byg10.isAir() || byc.getProgress(float2) >= 1.0f) {
            return;
        }
        ModelBlockRenderer.enableCaching();
        cyi.pushPose();
        cyi.translate(byc.getXOff(float2), byc.getYOff(float2), byc.getZOff(float2));
        if (byg10.getBlock() == Blocks.PISTON_HEAD && byc.getProgress(float2) <= 4.0f) {
            byg10 = ((AbstractStateHolder<O, BlockState>)byg10).<Comparable, Boolean>setValue((Property<Comparable>)PistonHeadBlock.SHORT, true);
            this.renderBlock(fk9, byg10, cyi, dqq, bjt8, false, integer6);
        }
        else if (byc.isSourcePiston() && !byc.isExtending()) {
            final PistonType bzi11 = (byg10.getBlock() == Blocks.STICKY_PISTON) ? PistonType.STICKY : PistonType.DEFAULT;
            BlockState byg11 = (((AbstractStateHolder<O, BlockState>)Blocks.PISTON_HEAD.defaultBlockState()).setValue(PistonHeadBlock.TYPE, bzi11)).<Comparable, Comparable>setValue((Property<Comparable>)PistonHeadBlock.FACING, (Comparable)byg10.<V>getValue((Property<V>)PistonBaseBlock.FACING));
            byg11 = ((AbstractStateHolder<O, BlockState>)byg11).<Comparable, Boolean>setValue((Property<Comparable>)PistonHeadBlock.SHORT, byc.getProgress(float2) >= 0.5f);
            this.renderBlock(fk9, byg11, cyi, dqq, bjt8, false, integer6);
            final BlockPos fk10 = fk9.relative(byc.getMovementDirection());
            cyi.popPose();
            cyi.pushPose();
            byg10 = ((AbstractStateHolder<O, BlockState>)byg10).<Comparable, Boolean>setValue((Property<Comparable>)PistonBaseBlock.EXTENDED, true);
            this.renderBlock(fk10, byg10, cyi, dqq, bjt8, true, integer6);
        }
        else {
            this.renderBlock(fk9, byg10, cyi, dqq, bjt8, false, integer6);
        }
        cyi.popPose();
        ModelBlockRenderer.clearCache();
    }
    
    private void renderBlock(final BlockPos fk, final BlockState byg, final PoseStack cyi, final MultiBufferSource dqq, final Level bjt, final boolean boolean6, final int integer) {
        final RenderType dqy9 = ItemBlockRenderTypes.getChunkRenderType(byg);
        final VertexConsumer cyl10 = dqq.getBuffer(dqy9);
        this.blockRenderer.getModelRenderer().tesselateBlock(bjt, this.blockRenderer.getBlockModel(byg), byg, fk, cyi, cyl10, boolean6, new Random(), byg.getSeed(fk), integer);
    }
}
