package net.minecraft.client.renderer.blockentity;

import net.minecraft.world.level.block.entity.BlockEntity;
import com.mojang.blaze3d.vertex.VertexConsumer;
import net.minecraft.world.item.DyeColor;
import net.minecraft.world.level.block.state.BlockState;
import com.mojang.math.Vector3f;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.resources.model.Material;
import net.minecraft.client.renderer.Sheets;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.level.block.ShulkerBoxBlock;
import net.minecraft.core.Direction;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.model.ShulkerModel;
import net.minecraft.world.level.block.entity.ShulkerBoxBlockEntity;

public class ShulkerBoxRenderer extends BlockEntityRenderer<ShulkerBoxBlockEntity> {
    private final ShulkerModel<?> model;
    
    public ShulkerBoxRenderer(final ShulkerModel<?> dmj, final BlockEntityRenderDispatcher dsn) {
        super(dsn);
        this.model = dmj;
    }
    
    @Override
    public void render(final ShulkerBoxBlockEntity bxd, final float float2, final PoseStack cyi, final MultiBufferSource dqq, final int integer5, final int integer6) {
        Direction fp8 = Direction.UP;
        if (bxd.hasLevel()) {
            final BlockState byg9 = bxd.getLevel().getBlockState(bxd.getBlockPos());
            if (byg9.getBlock() instanceof ShulkerBoxBlock) {
                fp8 = byg9.<Direction>getValue(ShulkerBoxBlock.FACING);
            }
        }
        final DyeColor bdg10 = bxd.getColor();
        Material ebv9;
        if (bdg10 == null) {
            ebv9 = Sheets.DEFAULT_SHULKER_TEXTURE_LOCATION;
        }
        else {
            ebv9 = Sheets.SHULKER_TEXTURE_LOCATION.get(bdg10.getId());
        }
        cyi.pushPose();
        cyi.translate(0.5, 0.5, 0.5);
        final float float3 = 0.9995f;
        cyi.scale(0.9995f, 0.9995f, 0.9995f);
        cyi.mulPose(fp8.getRotation());
        cyi.scale(1.0f, -1.0f, -1.0f);
        cyi.translate(0.0, -1.0, 0.0);
        final VertexConsumer cyl12 = ebv9.buffer(dqq, RenderType::entityCutoutNoCull);
        this.model.getBase().render(cyi, cyl12, integer5, integer6);
        cyi.translate(0.0, -bxd.getProgress(float2) * 0.5f, 0.0);
        cyi.mulPose(Vector3f.YP.rotationDegrees(270.0f * bxd.getProgress(float2)));
        this.model.getLid().render(cyi, cyl12, integer5, integer6);
        cyi.popPose();
    }
}
