package net.minecraft.client.renderer.blockentity;

import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.BaseSpawner;
import net.minecraft.world.entity.Entity;
import net.minecraft.client.Minecraft;
import net.minecraft.util.Mth;
import com.mojang.math.Vector3f;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.world.level.block.entity.SpawnerBlockEntity;

public class SpawnerRenderer extends BlockEntityRenderer<SpawnerBlockEntity> {
    public SpawnerRenderer(final BlockEntityRenderDispatcher dsn) {
        super(dsn);
    }
    
    @Override
    public void render(final SpawnerBlockEntity bxh, final float float2, final PoseStack cyi, final MultiBufferSource dqq, final int integer5, final int integer6) {
        cyi.pushPose();
        cyi.translate(0.5, 0.0, 0.5);
        final BaseSpawner bja8 = bxh.getSpawner();
        final Entity akn9 = bja8.getOrCreateDisplayEntity();
        if (akn9 != null) {
            float float3 = 0.53125f;
            final float float4 = Math.max(akn9.getBbWidth(), akn9.getBbHeight());
            if (float4 > 1.0) {
                float3 /= float4;
            }
            cyi.translate(0.0, 0.4000000059604645, 0.0);
            cyi.mulPose(Vector3f.YP.rotationDegrees((float)Mth.lerp(float2, bja8.getoSpin(), bja8.getSpin()) * 10.0f));
            cyi.translate(0.0, -0.20000000298023224, 0.0);
            cyi.mulPose(Vector3f.XP.rotationDegrees(-30.0f));
            cyi.scale(float3, float3, float3);
            Minecraft.getInstance().getEntityRenderDispatcher().<Entity>render(akn9, 0.0, 0.0, 0.0, 0.0f, float2, cyi, dqq, integer5);
        }
        cyi.popPose();
    }
}
