package net.minecraft.client.renderer.debug;

import com.mojang.blaze3d.vertex.BufferBuilder;
import net.minecraft.world.phys.shapes.VoxelShape;
import net.minecraft.world.level.block.state.BlockState;
import java.util.Iterator;
import net.minecraft.world.level.BlockGetter;
import com.mojang.blaze3d.vertex.DefaultVertexFormat;
import com.mojang.blaze3d.vertex.Tesselator;
import net.minecraft.core.Direction;
import net.minecraft.world.phys.AABB;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.core.BlockPos;
import com.mojang.blaze3d.systems.RenderSystem;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.Minecraft;

public class SolidFaceRenderer implements DebugRenderer.SimpleDebugRenderer {
    private final Minecraft minecraft;
    
    public SolidFaceRenderer(final Minecraft dbl) {
        this.minecraft = dbl;
    }
    
    @Override
    public void render(final PoseStack cyi, final MultiBufferSource dqq, final double double3, final double double4, final double double5) {
        final BlockGetter bjd10 = this.minecraft.player.level;
        RenderSystem.enableBlend();
        RenderSystem.defaultBlendFunc();
        RenderSystem.lineWidth(2.0f);
        RenderSystem.disableTexture();
        RenderSystem.depthMask(false);
        final BlockPos fk11 = new BlockPos(double3, double4, double5);
        for (final BlockPos fk12 : BlockPos.betweenClosed(fk11.offset(-6, -6, -6), fk11.offset(6, 6, 6))) {
            final BlockState byg14 = bjd10.getBlockState(fk12);
            if (byg14.getBlock() == Blocks.AIR) {
                continue;
            }
            final VoxelShape cwc15 = byg14.getShape(bjd10, fk12);
            for (final AABB cvc17 : cwc15.toAabbs()) {
                final AABB cvc18 = cvc17.move(fk12).inflate(0.002).move(-double3, -double4, -double5);
                final double double6 = cvc18.minX;
                final double double7 = cvc18.minY;
                final double double8 = cvc18.minZ;
                final double double9 = cvc18.maxX;
                final double double10 = cvc18.maxY;
                final double double11 = cvc18.maxZ;
                final float float31 = 1.0f;
                final float float32 = 0.0f;
                final float float33 = 0.0f;
                final float float34 = 0.5f;
                if (byg14.isFaceSturdy(bjd10, fk12, Direction.WEST)) {
                    final Tesselator cyj35 = Tesselator.getInstance();
                    final BufferBuilder cyd36 = cyj35.getBuilder();
                    cyd36.begin(5, DefaultVertexFormat.POSITION_COLOR);
                    cyd36.vertex(double6, double7, double8).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double6, double7, double11).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double6, double10, double8).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double6, double10, double11).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyj35.end();
                }
                if (byg14.isFaceSturdy(bjd10, fk12, Direction.SOUTH)) {
                    final Tesselator cyj35 = Tesselator.getInstance();
                    final BufferBuilder cyd36 = cyj35.getBuilder();
                    cyd36.begin(5, DefaultVertexFormat.POSITION_COLOR);
                    cyd36.vertex(double6, double10, double11).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double6, double7, double11).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double9, double10, double11).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double9, double7, double11).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyj35.end();
                }
                if (byg14.isFaceSturdy(bjd10, fk12, Direction.EAST)) {
                    final Tesselator cyj35 = Tesselator.getInstance();
                    final BufferBuilder cyd36 = cyj35.getBuilder();
                    cyd36.begin(5, DefaultVertexFormat.POSITION_COLOR);
                    cyd36.vertex(double9, double7, double11).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double9, double7, double8).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double9, double10, double11).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double9, double10, double8).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyj35.end();
                }
                if (byg14.isFaceSturdy(bjd10, fk12, Direction.NORTH)) {
                    final Tesselator cyj35 = Tesselator.getInstance();
                    final BufferBuilder cyd36 = cyj35.getBuilder();
                    cyd36.begin(5, DefaultVertexFormat.POSITION_COLOR);
                    cyd36.vertex(double9, double10, double8).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double9, double7, double8).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double6, double10, double8).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double6, double7, double8).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyj35.end();
                }
                if (byg14.isFaceSturdy(bjd10, fk12, Direction.DOWN)) {
                    final Tesselator cyj35 = Tesselator.getInstance();
                    final BufferBuilder cyd36 = cyj35.getBuilder();
                    cyd36.begin(5, DefaultVertexFormat.POSITION_COLOR);
                    cyd36.vertex(double6, double7, double8).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double9, double7, double8).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double6, double7, double11).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double9, double7, double11).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyj35.end();
                }
                if (byg14.isFaceSturdy(bjd10, fk12, Direction.UP)) {
                    final Tesselator cyj35 = Tesselator.getInstance();
                    final BufferBuilder cyd36 = cyj35.getBuilder();
                    cyd36.begin(5, DefaultVertexFormat.POSITION_COLOR);
                    cyd36.vertex(double6, double10, double8).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double6, double10, double11).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double9, double10, double8).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyd36.vertex(double9, double10, double11).color(1.0f, 0.0f, 0.0f, 0.5f).endVertex();
                    cyj35.end();
                }
            }
        }
        RenderSystem.depthMask(true);
        RenderSystem.enableTexture();
        RenderSystem.disableBlend();
    }
}
