package net.minecraft.client.renderer.entity;

import net.minecraft.world.entity.LivingEntity;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.model.HorseModel;
import net.minecraft.world.entity.animal.horse.AbstractHorse;

public abstract class AbstractHorseRenderer<T extends AbstractHorse, M extends HorseModel<T>> extends MobRenderer<T, M> {
    private final float scale;
    
    public AbstractHorseRenderer(final EntityRenderDispatcher dvc, final M dle, final float float3) {
        super(dvc, dle, 0.75f);
        this.scale = float3;
    }
    
    @Override
    protected void scale(final T aub, final PoseStack cyi, final float float3) {
        cyi.scale(this.scale, this.scale, this.scale);
        super.scale(aub, cyi, float3);
    }
}
