package net.minecraft.client.renderer.entity;

import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.Mob;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.entity.layers.RenderLayer;
import net.minecraft.client.model.HumanoidModel;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.client.renderer.entity.layers.HumanoidArmorLayer;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.model.ZombieModel;
import net.minecraft.world.entity.monster.Zombie;

public abstract class AbstractZombieRenderer<T extends Zombie, M extends ZombieModel<T>> extends HumanoidMobRenderer<T, M> {
    private static final ResourceLocation ZOMBIE_LOCATION;
    
    protected AbstractZombieRenderer(final EntityRenderDispatcher dvc, final M dnb2, final M dnb3, final M dnb4) {
        super(dvc, dnb2, 0.5f);
        this.addLayer((RenderLayer<T, M>)new HumanoidArmorLayer((RenderLayerParent<LivingEntity, HumanoidModel>)this, dnb3, dnb4));
    }
    
    @Override
    public ResourceLocation getTextureLocation(final Zombie axm) {
        return AbstractZombieRenderer.ZOMBIE_LOCATION;
    }
    
    @Override
    protected void setupRotations(final T axm, final PoseStack cyi, final float float3, float float4, final float float5) {
        if (axm.isUnderWaterConverting()) {
            float4 += (float)(Math.cos(axm.tickCount * 3.25) * 3.141592653589793 * 0.25);
        }
        super.setupRotations(axm, cyi, float3, float4, float5);
    }
    
    static {
        ZOMBIE_LOCATION = new ResourceLocation("textures/entity/zombie/zombie.png");
    }
}
