package net.minecraft.client.renderer.entity;

import net.minecraft.client.renderer.texture.TextureAtlas;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.block.BlockRenderDispatcher;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.BlockAndTintGetter;
import net.minecraft.client.renderer.texture.OverlayTexture;
import java.util.Random;
import net.minecraft.client.renderer.ItemBlockRenderTypes;
import net.minecraft.client.Minecraft;
import net.minecraft.world.entity.Entity;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.block.RenderShape;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.world.entity.item.FallingBlockEntity;

public class FallingBlockRenderer extends EntityRenderer<FallingBlockEntity> {
    public FallingBlockRenderer(final EntityRenderDispatcher dvc) {
        super(dvc);
        this.shadowRadius = 0.5f;
    }
    
    @Override
    public void render(final FallingBlockEntity avx, final float float2, final float float3, final PoseStack cyi, final MultiBufferSource dqq, final int integer) {
        final BlockState byg8 = avx.getBlockState();
        if (byg8.getRenderShape() != RenderShape.MODEL) {
            return;
        }
        final Level bjt9 = avx.getLevel();
        if (byg8 == bjt9.getBlockState(new BlockPos(avx)) || byg8.getRenderShape() == RenderShape.INVISIBLE) {
            return;
        }
        cyi.pushPose();
        final BlockPos fk10 = new BlockPos(avx.getX(), avx.getBoundingBox().maxY, avx.getZ());
        cyi.translate(-0.5, 0.0, -0.5);
        final BlockRenderDispatcher drh11 = Minecraft.getInstance().getBlockRenderer();
        drh11.getModelRenderer().tesselateBlock(bjt9, drh11.getBlockModel(byg8), byg8, fk10, cyi, dqq.getBuffer(ItemBlockRenderTypes.getChunkRenderType(byg8)), false, new Random(), byg8.getSeed(avx.getStartPos()), OverlayTexture.NO_OVERLAY);
        cyi.popPose();
        super.render(avx, float2, float3, cyi, dqq, integer);
    }
    
    @Override
    public ResourceLocation getTextureLocation(final FallingBlockEntity avx) {
        return TextureAtlas.LOCATION_BLOCKS;
    }
}
