package net.minecraft.client.renderer.entity;

import net.minecraft.world.entity.Entity;
import net.minecraft.client.renderer.texture.TextureAtlas;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.texture.OverlayTexture;
import net.minecraft.client.renderer.block.model.ItemTransforms;
import com.mojang.math.Vector3f;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.world.entity.projectile.FireworkRocketEntity;

public class FireworkEntityRenderer extends EntityRenderer<FireworkRocketEntity> {
    private final ItemRenderer itemRenderer;
    
    public FireworkEntityRenderer(final EntityRenderDispatcher dvc, final ItemRenderer dvw) {
        super(dvc);
        this.itemRenderer = dvw;
    }
    
    @Override
    public void render(final FireworkRocketEntity ayr, final float float2, final float float3, final PoseStack cyi, final MultiBufferSource dqq, final int integer) {
        cyi.pushPose();
        cyi.mulPose(this.entityRenderDispatcher.cameraOrientation());
        cyi.mulPose(Vector3f.YP.rotationDegrees(180.0f));
        if (ayr.isShotAtAngle()) {
            cyi.mulPose(Vector3f.ZP.rotationDegrees(180.0f));
            cyi.mulPose(Vector3f.YP.rotationDegrees(180.0f));
            cyi.mulPose(Vector3f.XP.rotationDegrees(90.0f));
        }
        this.itemRenderer.renderStatic(ayr.getItem(), ItemTransforms.TransformType.GROUND, integer, OverlayTexture.NO_OVERLAY, cyi, dqq);
        cyi.popPose();
        super.render(ayr, float2, float3, cyi, dqq, integer);
    }
    
    @Override
    public ResourceLocation getTextureLocation(final FireworkRocketEntity ayr) {
        return TextureAtlas.LOCATION_BLOCKS;
    }
}
