package net.minecraft.client.renderer.entity;

import net.minecraft.world.entity.Entity;
import com.mojang.blaze3d.vertex.VertexConsumer;
import net.minecraft.client.renderer.texture.OverlayTexture;
import net.minecraft.util.Mth;
import com.mojang.math.Vector3f;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.model.TridentModel;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.entity.projectile.ThrownTrident;

public class ThrownTridentRenderer extends EntityRenderer<ThrownTrident> {
    public static final ResourceLocation TRIDENT_LOCATION;
    private final TridentModel model;
    
    public ThrownTridentRenderer(final EntityRenderDispatcher dvc) {
        super(dvc);
        this.model = new TridentModel();
    }
    
    @Override
    public void render(final ThrownTrident azh, final float float2, final float float3, final PoseStack cyi, final MultiBufferSource dqq, final int integer) {
        cyi.pushPose();
        cyi.mulPose(Vector3f.YP.rotationDegrees(Mth.lerp(float3, azh.yRotO, azh.yRot) - 90.0f));
        cyi.mulPose(Vector3f.ZP.rotationDegrees(Mth.lerp(float3, azh.xRotO, azh.xRot) + 90.0f));
        final VertexConsumer cyl8 = ItemRenderer.getFoilBuffer(dqq, this.model.renderType(this.getTextureLocation(azh)), false, azh.isFoil());
        this.model.renderToBuffer(cyi, cyl8, integer, OverlayTexture.NO_OVERLAY, 1.0f, 1.0f, 1.0f, 1.0f);
        cyi.popPose();
        super.render(azh, float2, float3, cyi, dqq, integer);
    }
    
    @Override
    public ResourceLocation getTextureLocation(final ThrownTrident azh) {
        return ThrownTridentRenderer.TRIDENT_LOCATION;
    }
    
    static {
        TRIDENT_LOCATION = new ResourceLocation("textures/entity/trident.png");
    }
}
