package net.minecraft.client.renderer.entity;

import net.minecraft.world.entity.Entity;
import net.minecraft.client.renderer.texture.TextureAtlas;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.level.block.Blocks;
import com.mojang.math.Vector3f;
import net.minecraft.util.Mth;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.world.entity.item.PrimedTnt;

public class TntRenderer extends EntityRenderer<PrimedTnt> {
    public TntRenderer(final EntityRenderDispatcher dvc) {
        super(dvc);
        this.shadowRadius = 0.5f;
    }
    
    @Override
    public void render(final PrimedTnt avz, final float float2, final float float3, final PoseStack cyi, final MultiBufferSource dqq, final int integer) {
        cyi.pushPose();
        cyi.translate(0.0, 0.5, 0.0);
        if (avz.getLife() - float3 + 1.0f < 10.0f) {
            float float4 = 1.0f - (avz.getLife() - float3 + 1.0f) / 10.0f;
            float4 = Mth.clamp(float4, 0.0f, 1.0f);
            float4 *= float4;
            float4 *= float4;
            final float float5 = 1.0f + float4 * 0.3f;
            cyi.scale(float5, float5, float5);
        }
        cyi.mulPose(Vector3f.YP.rotationDegrees(-90.0f));
        cyi.translate(-0.5, -0.5, 0.5);
        cyi.mulPose(Vector3f.YP.rotationDegrees(90.0f));
        TntMinecartRenderer.renderWhiteSolidBlock(Blocks.TNT.defaultBlockState(), cyi, dqq, integer, avz.getLife() / 5 % 2 == 0);
        cyi.popPose();
        super.render(avz, float2, float3, cyi, dqq, integer);
    }
    
    @Override
    public ResourceLocation getTextureLocation(final PrimedTnt avz) {
        return TextureAtlas.LOCATION_BLOCKS;
    }
}
