package net.minecraft.client.renderer.entity;

import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.Mob;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.entity.layers.RenderLayer;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.client.renderer.entity.layers.WitchItemLayer;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.model.WitchModel;
import net.minecraft.world.entity.monster.Witch;

public class WitchRenderer extends MobRenderer<Witch, WitchModel<Witch>> {
    private static final ResourceLocation WITCH_LOCATION;
    
    public WitchRenderer(final EntityRenderDispatcher dvc) {
        super(dvc, new WitchModel(0.0f), 0.5f);
        this.addLayer((RenderLayer<Witch, WitchModel<Witch>>)new WitchItemLayer((RenderLayerParent<LivingEntity, WitchModel<LivingEntity>>)this));
    }
    
    @Override
    public void render(final Witch axk, final float float2, final float float3, final PoseStack cyi, final MultiBufferSource dqq, final int integer) {
        ((WitchModel)this.model).setHoldingItem(!axk.getMainHandItem().isEmpty());
        super.render(axk, float2, float3, cyi, dqq, integer);
    }
    
    @Override
    public ResourceLocation getTextureLocation(final Witch axk) {
        return WitchRenderer.WITCH_LOCATION;
    }
    
    @Override
    protected void scale(final Witch axk, final PoseStack cyi, final float float3) {
        final float float4 = 0.9375f;
        cyi.scale(0.9375f, 0.9375f, 0.9375f);
    }
    
    static {
        WITCH_LOCATION = new ResourceLocation("textures/entity/witch.png");
    }
}
