package net.minecraft.client.renderer.entity.layers;

import net.minecraft.world.entity.Entity;
import com.mojang.blaze3d.vertex.VertexConsumer;
import net.minecraft.world.item.ItemStack;
import net.minecraft.client.renderer.texture.OverlayTexture;
import net.minecraft.client.renderer.RenderType;
import com.mojang.math.Vector3f;
import net.minecraft.util.Mth;
import net.minecraft.world.item.Items;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.player.PlayerModelPart;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.entity.RenderLayerParent;
import net.minecraft.client.model.PlayerModel;
import net.minecraft.client.player.AbstractClientPlayer;

public class CapeLayer extends RenderLayer<AbstractClientPlayer, PlayerModel<AbstractClientPlayer>> {
    public CapeLayer(final RenderLayerParent<AbstractClientPlayer, PlayerModel<AbstractClientPlayer>> dws) {
        super(dws);
    }
    
    @Override
    public void render(final PoseStack cyi, final MultiBufferSource dqq, final int integer, final AbstractClientPlayer dpv, final float float5, final float float6, final float float7, final float float8, final float float9, final float float10) {
        if (!dpv.isCapeLoaded() || dpv.isInvisible() || !dpv.isModelPartShown(PlayerModelPart.CAPE) || dpv.getCloakTextureLocation() == null) {
            return;
        }
        final ItemStack bek12 = dpv.getItemBySlot(EquipmentSlot.CHEST);
        if (bek12.getItem() == Items.ELYTRA) {
            return;
        }
        cyi.pushPose();
        cyi.translate(0.0, 0.0, 0.125);
        final double double13 = Mth.lerp(float7, dpv.xCloakO, dpv.xCloak) - Mth.lerp(float7, dpv.xo, dpv.getX());
        final double double14 = Mth.lerp(float7, dpv.yCloakO, dpv.yCloak) - Mth.lerp(float7, dpv.yo, dpv.getY());
        final double double15 = Mth.lerp(float7, dpv.zCloakO, dpv.zCloak) - Mth.lerp(float7, dpv.zo, dpv.getZ());
        final float float11 = dpv.yBodyRotO + (dpv.yBodyRot - dpv.yBodyRotO);
        final double double16 = Mth.sin(float11 * 0.017453292f);
        final double double17 = -Mth.cos(float11 * 0.017453292f);
        float float12 = (float)double14 * 10.0f;
        float12 = Mth.clamp(float12, -6.0f, 32.0f);
        float float13 = (float)(double13 * double16 + double15 * double17) * 100.0f;
        float13 = Mth.clamp(float13, 0.0f, 150.0f);
        float float14 = (float)(double13 * double17 - double15 * double16) * 100.0f;
        float14 = Mth.clamp(float14, -20.0f, 20.0f);
        if (float13 < 0.0f) {
            float13 = 0.0f;
        }
        final float float15 = Mth.lerp(float7, dpv.oBob, dpv.bob);
        float12 += Mth.sin(Mth.lerp(float7, dpv.walkDistO, dpv.walkDist) * 6.0f) * 32.0f * float15;
        if (dpv.isCrouching()) {
            float12 += 25.0f;
        }
        cyi.mulPose(Vector3f.XP.rotationDegrees(6.0f + float13 / 2.0f + float12));
        cyi.mulPose(Vector3f.ZP.rotationDegrees(float14 / 2.0f));
        cyi.mulPose(Vector3f.YP.rotationDegrees(180.0f - float14 / 2.0f));
        final VertexConsumer cyl28 = dqq.getBuffer(RenderType.entitySolid(dpv.getCloakTextureLocation()));
        ((RenderLayer<T, PlayerModel>)this).getParentModel().renderCloak(cyi, cyl28, integer, OverlayTexture.NO_OVERLAY);
        cyi.popPose();
    }
}
