package net.minecraft.client.renderer.entity.layers;

import net.minecraft.world.entity.Entity;
import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.math.Vector3f;
import net.minecraft.util.Mth;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.client.renderer.entity.LivingEntityRenderer;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.entity.RenderLayerParent;
import net.minecraft.client.model.PlayerModel;
import net.minecraft.client.player.AbstractClientPlayer;

public class Deadmau5EarsLayer extends RenderLayer<AbstractClientPlayer, PlayerModel<AbstractClientPlayer>> {
    public Deadmau5EarsLayer(final RenderLayerParent<AbstractClientPlayer, PlayerModel<AbstractClientPlayer>> dws) {
        super(dws);
    }
    
    @Override
    public void render(final PoseStack cyi, final MultiBufferSource dqq, final int integer, final AbstractClientPlayer dpv, final float float5, final float float6, final float float7, final float float8, final float float9, final float float10) {
        if (!"deadmau5".equals(dpv.getName().getString()) || !dpv.isSkinLoaded() || dpv.isInvisible()) {
            return;
        }
        final VertexConsumer cyl12 = dqq.getBuffer(RenderType.entitySolid(dpv.getSkinTextureLocation()));
        final int integer2 = LivingEntityRenderer.getOverlayCoords(dpv, 0.0f);
        for (int integer3 = 0; integer3 < 2; ++integer3) {
            final float float11 = Mth.lerp(float7, dpv.yRotO, dpv.yRot) - Mth.lerp(float7, dpv.yBodyRotO, dpv.yBodyRot);
            final float float12 = Mth.lerp(float7, dpv.xRotO, dpv.xRot);
            cyi.pushPose();
            cyi.mulPose(Vector3f.YP.rotationDegrees(float11));
            cyi.mulPose(Vector3f.XP.rotationDegrees(float12));
            cyi.translate(0.375f * (integer3 * 2 - 1), 0.0, 0.0);
            cyi.translate(0.0, -0.375, 0.0);
            cyi.mulPose(Vector3f.XP.rotationDegrees(-float12));
            cyi.mulPose(Vector3f.YP.rotationDegrees(-float11));
            final float float13 = 1.3333334f;
            cyi.scale(1.3333334f, 1.3333334f, 1.3333334f);
            ((RenderLayer<T, PlayerModel>)this).getParentModel().renderEars(cyi, cyl12, integer, integer2);
            cyi.popPose();
        }
    }
}
