package net.minecraft.client.renderer.entity.layers;

import net.minecraft.resources.ResourceLocation;
import com.mojang.blaze3d.vertex.VertexConsumer;
import net.minecraft.client.renderer.texture.OverlayTexture;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.world.entity.PowerableMob;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.entity.RenderLayerParent;
import net.minecraft.client.model.EntityModel;

public abstract class EnergySwirlLayer<T extends Entity, M extends EntityModel<T>> extends RenderLayer<T, M> {
    public EnergySwirlLayer(final RenderLayerParent<T, M> dws) {
        super(dws);
    }
    
    @Override
    public void render(final PoseStack cyi, final MultiBufferSource dqq, final int integer, final T akn, final float float5, final float float6, final float float7, final float float8, final float float9, final float float10) {
        if (!((PowerableMob)akn).isPowered()) {
            return;
        }
        final float float11 = ((Entity)akn).tickCount + float7;
        final EntityModel<T> dkx13 = this.model();
        dkx13.prepareMobModel(akn, float5, float6, float7);
        this.getParentModel().copyPropertiesTo(dkx13);
        final VertexConsumer cyl14 = dqq.getBuffer(RenderType.energySwirl(this.getTextureLocation(), this.xOffset(float11), float11 * 0.01f));
        dkx13.setupAnim(akn, float5, float6, float8, float9, float10);
        dkx13.renderToBuffer(cyi, cyl14, integer, OverlayTexture.NO_OVERLAY, 0.5f, 0.5f, 0.5f, 1.0f);
    }
    
    protected abstract float xOffset(final float float1);
    
    protected abstract ResourceLocation getTextureLocation();
    
    protected abstract EntityModel<T> model();
}
