package net.minecraft.client.renderer.entity.layers;

import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.client.renderer.entity.RenderLayerParent;
import net.minecraft.client.model.HumanoidModel;
import net.minecraft.world.entity.LivingEntity;

public class HumanoidArmorLayer<T extends LivingEntity, M extends HumanoidModel<T>, A extends HumanoidModel<T>> extends AbstractArmorLayer<T, M, A> {
    public HumanoidArmorLayer(final RenderLayerParent<T, M> dws, final A dlg2, final A dlg3) {
        super(dws, dlg2, dlg3);
    }
    
    @Override
    protected void setPartVisibility(final A dlg, final EquipmentSlot aks) {
        this.hideAllArmor(dlg);
        switch (aks) {
            case HEAD: {
                dlg.head.visible = true;
                dlg.hat.visible = true;
                break;
            }
            case CHEST: {
                dlg.body.visible = true;
                dlg.rightArm.visible = true;
                dlg.leftArm.visible = true;
                break;
            }
            case LEGS: {
                dlg.body.visible = true;
                dlg.rightLeg.visible = true;
                dlg.leftLeg.visible = true;
                break;
            }
            case FEET: {
                dlg.rightLeg.visible = true;
                dlg.leftLeg.visible = true;
                break;
            }
        }
    }
    
    @Override
    protected void hideAllArmor(final A dlg) {
        dlg.setAllVisible(false);
    }
}
