package net.minecraft.client.renderer.entity.layers;

import net.minecraft.world.entity.Entity;
import net.minecraft.client.Minecraft;
import com.mojang.math.Vector3f;
import net.minecraft.client.model.ArmedModel;
import net.minecraft.world.item.ItemStack;
import net.minecraft.client.renderer.block.model.ItemTransforms;
import net.minecraft.world.entity.HumanoidArm;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.entity.RenderLayerParent;
import net.minecraft.world.entity.LivingEntity;

public class ItemInHandLayer<T extends LivingEntity, M extends EntityModel> extends RenderLayer<T, M> {
    public ItemInHandLayer(final RenderLayerParent<T, M> dws) {
        super(dws);
    }
    
    @Override
    public void render(final PoseStack cyi, final MultiBufferSource dqq, final int integer, final T akw, final float float5, final float float6, final float float7, final float float8, final float float9, final float float10) {
        final boolean boolean12 = akw.getMainArm() == HumanoidArm.RIGHT;
        final ItemStack bek13 = boolean12 ? akw.getOffhandItem() : akw.getMainHandItem();
        final ItemStack bek14 = boolean12 ? akw.getMainHandItem() : akw.getOffhandItem();
        if (bek13.isEmpty() && bek14.isEmpty()) {
            return;
        }
        cyi.pushPose();
        if (((net.minecraft.client.model.EntityModel)this.getParentModel()).young) {
            final float float11 = 0.5f;
            cyi.translate(0.0, 0.75, 0.0);
            cyi.scale(0.5f, 0.5f, 0.5f);
        }
        this.renderArmWithItem(akw, bek14, ItemTransforms.TransformType.THIRD_PERSON_RIGHT_HAND, HumanoidArm.RIGHT, cyi, dqq, integer);
        this.renderArmWithItem(akw, bek13, ItemTransforms.TransformType.THIRD_PERSON_LEFT_HAND, HumanoidArm.LEFT, cyi, dqq, integer);
        cyi.popPose();
    }
    
    private void renderArmWithItem(final LivingEntity akw, final ItemStack bek, final ItemTransforms.TransformType b, final HumanoidArm akv, final PoseStack cyi, final MultiBufferSource dqq, final int integer) {
        if (bek.isEmpty()) {
            return;
        }
        cyi.pushPose();
        this.getParentModel().translateToHand(akv, cyi);
        cyi.mulPose(Vector3f.XP.rotationDegrees(-90.0f));
        cyi.mulPose(Vector3f.YP.rotationDegrees(180.0f));
        final boolean boolean9 = akv == HumanoidArm.LEFT;
        cyi.translate((boolean9 ? -1 : 1) / 16.0f, 0.125, -0.625);
        Minecraft.getInstance().getItemInHandRenderer().renderItem(akw, bek, b, boolean9, cyi, dqq, integer);
        cyi.popPose();
    }
}
