package net.minecraft.client.renderer.entity.layers;

import net.minecraft.world.entity.Entity;
import com.mojang.blaze3d.vertex.VertexConsumer;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.client.renderer.texture.OverlayTexture;
import net.minecraft.client.renderer.entity.ParrotRenderer;
import net.minecraft.world.entity.EntityType;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.entity.RenderLayerParent;
import net.minecraft.client.model.ParrotModel;
import net.minecraft.client.model.PlayerModel;
import net.minecraft.world.entity.player.Player;

public class ParrotOnShoulderLayer<T extends Player> extends RenderLayer<T, PlayerModel<T>> {
    private final ParrotModel model;
    
    public ParrotOnShoulderLayer(final RenderLayerParent<T, PlayerModel<T>> dws) {
        super(dws);
        this.model = new ParrotModel();
    }
    
    @Override
    public void render(final PoseStack cyi, final MultiBufferSource dqq, final int integer, final T ayg, final float float5, final float float6, final float float7, final float float8, final float float9, final float float10) {
        this.render(cyi, dqq, integer, ayg, float5, float6, float9, float10, true);
        this.render(cyi, dqq, integer, ayg, float5, float6, float9, float10, false);
    }
    
    private void render(final PoseStack cyi, final MultiBufferSource dqq, final int integer, final T ayg, final float float5, final float float6, final float float7, final float float8, final boolean boolean9) {
        final CompoundTag jt11 = boolean9 ? ayg.getShoulderEntityLeft() : ayg.getShoulderEntityRight();
        final CompoundTag compoundTag;
        final VertexConsumer cyl13;
        EntityType.byString(jt11.getString("id")).filter(akr -> akr == EntityType.PARROT).ifPresent(akr -> {
            cyi.pushPose();
            cyi.translate(boolean9 ? 0.4000000059604645 : -0.4000000059604645, ayg.isCrouching() ? -1.2999999523162842 : -1.5, 0.0);
            cyl13 = dqq.getBuffer(this.model.renderType(ParrotRenderer.PARROT_LOCATIONS[compoundTag.getInt("Variant")]));
            this.model.renderOnShoulder(cyi, cyl13, integer, OverlayTexture.NO_OVERLAY, float5, float6, float7, float8, ayg.tickCount);
            cyi.popPose();
        });
    }
}
