package net.minecraft.client.renderer.entity.layers;

import com.mojang.blaze3d.vertex.VertexConsumer;
import net.minecraft.client.renderer.entity.LivingEntityRenderer;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.RenderLayerParent;
import net.minecraft.client.model.EntityModel;
import net.minecraft.world.entity.Entity;

public abstract class RenderLayer<T extends Entity, M extends EntityModel<T>> {
    private final RenderLayerParent<T, M> renderer;
    
    public RenderLayer(final RenderLayerParent<T, M> dws) {
        this.renderer = dws;
    }
    
    protected static <T extends LivingEntity> void coloredCutoutModelCopyLayerRender(final EntityModel<T> dkx1, final EntityModel<T> dkx2, final ResourceLocation sm, final PoseStack cyi, final MultiBufferSource dqq, final int integer, final T akw, final float float8, final float float9, final float float10, final float float11, final float float12, final float float13, final float float14, final float float15, final float float16) {
        if (!akw.isInvisible()) {
            dkx1.copyPropertiesTo(dkx2);
            dkx2.prepareMobModel(akw, float8, float9, float13);
            dkx2.setupAnim(akw, float8, float9, float10, float11, float12);
            RenderLayer.<T>renderColoredCutoutModel(dkx2, sm, cyi, dqq, integer, akw, float14, float15, float16);
        }
    }
    
    protected static <T extends LivingEntity> void renderColoredCutoutModel(final EntityModel<T> dkx, final ResourceLocation sm, final PoseStack cyi, final MultiBufferSource dqq, final int integer, final T akw, final float float7, final float float8, final float float9) {
        final VertexConsumer cyl10 = dqq.getBuffer(RenderType.entityCutoutNoCull(sm));
        dkx.renderToBuffer(cyi, cyl10, integer, LivingEntityRenderer.getOverlayCoords(akw, 0.0f), float7, float8, float9, 1.0f);
    }
    
    public M getParentModel() {
        return this.renderer.getModel();
    }
    
    protected ResourceLocation getTextureLocation(final T akn) {
        return this.renderer.getTextureLocation(akn);
    }
    
    public abstract void render(final PoseStack cyi, final MultiBufferSource dqq, final int integer, final T akn, final float float5, final float float6, final float float7, final float float8, final float float9, final float float10);
}
