package net.minecraft.client.renderer.entity.layers;

import net.minecraft.world.entity.Entity;
import com.mojang.blaze3d.vertex.VertexConsumer;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.DyeColor;
import net.minecraft.client.model.geom.ModelPart;
import com.mojang.math.Quaternion;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.client.renderer.entity.LivingEntityRenderer;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.renderer.entity.ShulkerRenderer;
import net.minecraft.client.renderer.MultiBufferSource;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.entity.RenderLayerParent;
import net.minecraft.client.model.ShulkerModel;
import net.minecraft.world.entity.monster.Shulker;

public class ShulkerHeadLayer extends RenderLayer<Shulker, ShulkerModel<Shulker>> {
    public ShulkerHeadLayer(final RenderLayerParent<Shulker, ShulkerModel<Shulker>> dws) {
        super(dws);
    }
    
    @Override
    public void render(final PoseStack cyi, final MultiBufferSource dqq, final int integer, final Shulker axb, final float float5, final float float6, final float float7, final float float8, final float float9, final float float10) {
        cyi.pushPose();
        cyi.translate(0.0, 1.0, 0.0);
        cyi.scale(-1.0f, -1.0f, 1.0f);
        final Quaternion c12 = axb.getAttachFace().getOpposite().getRotation();
        c12.conj();
        cyi.mulPose(c12);
        cyi.scale(-1.0f, -1.0f, 1.0f);
        cyi.translate(0.0, -1.0, 0.0);
        final ModelPart dnf13 = ((RenderLayer<T, ShulkerModel>)this).getParentModel().getHead();
        dnf13.yRot = float9 * 0.017453292f;
        dnf13.xRot = float10 * 0.017453292f;
        final DyeColor bdg14 = axb.getColor();
        ResourceLocation sm15;
        if (bdg14 == null) {
            sm15 = ShulkerRenderer.DEFAULT_TEXTURE_LOCATION;
        }
        else {
            sm15 = ShulkerRenderer.TEXTURE_LOCATION[bdg14.getId()];
        }
        final VertexConsumer cyl16 = dqq.getBuffer(RenderType.entitySolid(sm15));
        dnf13.render(cyi, cyl16, integer, LivingEntityRenderer.getOverlayCoords(axb, 0.0f));
        cyi.popPose();
    }
}
