package net.minecraft.core.dispenser;

import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.level.Level;
import net.minecraft.core.Position;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.level.block.DispenserBlock;
import net.minecraft.core.Direction;
import net.minecraft.world.item.ItemStack;
import net.minecraft.core.BlockSource;

public class DefaultDispenseItemBehavior implements DispenseItemBehavior {
    @Override
    public final ItemStack dispense(final BlockSource fl, final ItemStack bek) {
        final ItemStack bek2 = this.execute(fl, bek);
        this.playSound(fl);
        this.playAnimation(fl, fl.getBlockState().<Direction>getValue((Property<Direction>)DispenserBlock.FACING));
        return bek2;
    }
    
    protected ItemStack execute(final BlockSource fl, final ItemStack bek) {
        final Direction fp4 = fl.getBlockState().<Direction>getValue((Property<Direction>)DispenserBlock.FACING);
        final Position fz5 = DispenserBlock.getDispensePosition(fl);
        final ItemStack bek2 = bek.split(1);
        spawnItem(fl.getLevel(), bek2, 6, fp4, fz5);
        return bek;
    }
    
    public static void spawnItem(final Level bjt, final ItemStack bek, final int integer, final Direction fp, final Position fz) {
        final double double6 = fz.x();
        double double7 = fz.y();
        final double double8 = fz.z();
        if (fp.getAxis() == Direction.Axis.Y) {
            double7 -= 0.125;
        }
        else {
            double7 -= 0.15625;
        }
        final ItemEntity avy12 = new ItemEntity(bjt, double6, double7, double8, bek);
        final double double9 = bjt.random.nextDouble() * 0.1 + 0.2;
        avy12.setDeltaMovement(bjt.random.nextGaussian() * 0.007499999832361937 * integer + fp.getStepX() * double9, bjt.random.nextGaussian() * 0.007499999832361937 * integer + 0.20000000298023224, bjt.random.nextGaussian() * 0.007499999832361937 * integer + fp.getStepZ() * double9);
        bjt.addFreshEntity(avy12);
    }
    
    protected void playSound(final BlockSource fl) {
        fl.getLevel().levelEvent(1000, fl.getPos(), 0);
    }
    
    protected void playAnimation(final BlockSource fl, final Direction fp) {
        fl.getLevel().levelEvent(2000, fl.getPos(), fp.get3DDataValue());
    }
}
