package net.minecraft.network.protocol.game;

import net.minecraft.network.PacketListener;

public interface ClientGamePacketListener extends PacketListener {
    void handleAddEntity(final ClientboundAddEntityPacket lx);
    
    void handleAddExperienceOrb(final ClientboundAddExperienceOrbPacket ly);
    
    void handleAddGlobalEntity(final ClientboundAddGlobalEntityPacket lz);
    
    void handleAddMob(final ClientboundAddMobPacket ma);
    
    void handleAddObjective(final ClientboundSetObjectivePacket oq);
    
    void handleAddPainting(final ClientboundAddPaintingPacket mb);
    
    void handleAddPlayer(final ClientboundAddPlayerPacket mc);
    
    void handleAnimate(final ClientboundAnimatePacket md);
    
    void handleAwardStats(final ClientboundAwardStatsPacket me);
    
    void handleAddOrRemoveRecipes(final ClientboundRecipePacket nx);
    
    void handleBlockDestruction(final ClientboundBlockDestructionPacket mg);
    
    void handleOpenSignEditor(final ClientboundOpenSignEditorPacket nq);
    
    void handleBlockEntityData(final ClientboundBlockEntityDataPacket mh);
    
    void handleBlockEvent(final ClientboundBlockEventPacket mi);
    
    void handleBlockUpdate(final ClientboundBlockUpdatePacket mj);
    
    void handleChat(final ClientboundChatPacket mm);
    
    void handleChunkBlocksUpdate(final ClientboundChunkBlocksUpdatePacket mn);
    
    void handleMapItemData(final ClientboundMapItemDataPacket nk);
    
    void handleContainerAck(final ClientboundContainerAckPacket mq);
    
    void handleContainerClose(final ClientboundContainerClosePacket mr);
    
    void handleContainerContent(final ClientboundContainerSetContentPacket ms);
    
    void handleHorseScreenOpen(final ClientboundHorseScreenOpenPacket nd);
    
    void handleContainerSetData(final ClientboundContainerSetDataPacket mt);
    
    void handleContainerSetSlot(final ClientboundContainerSetSlotPacket mu);
    
    void handleCustomPayload(final ClientboundCustomPayloadPacket mw);
    
    void handleDisconnect(final ClientboundDisconnectPacket my);
    
    void handleEntityEvent(final ClientboundEntityEventPacket mz);
    
    void handleEntityLinkPacket(final ClientboundSetEntityLinkPacket ol);
    
    void handleSetEntityPassengersPacket(final ClientboundSetPassengersPacket or);
    
    void handleExplosion(final ClientboundExplodePacket na);
    
    void handleGameEvent(final ClientboundGameEventPacket nc);
    
    void handleKeepAlive(final ClientboundKeepAlivePacket ne);
    
    void handleLevelChunk(final ClientboundLevelChunkPacket nf);
    
    void handleForgetLevelChunk(final ClientboundForgetLevelChunkPacket nb);
    
    void handleLevelEvent(final ClientboundLevelEventPacket ng);
    
    void handleLogin(final ClientboundLoginPacket nj);
    
    void handleMoveEntity(final ClientboundMoveEntityPacket nm);
    
    void handleMovePlayer(final ClientboundPlayerPositionPacket nw);
    
    void handleParticleEvent(final ClientboundLevelParticlesPacket nh);
    
    void handlePlayerAbilities(final ClientboundPlayerAbilitiesPacket ns);
    
    void handlePlayerInfo(final ClientboundPlayerInfoPacket nu);
    
    void handleRemoveEntity(final ClientboundRemoveEntitiesPacket ny);
    
    void handleRemoveMobEffect(final ClientboundRemoveMobEffectPacket nz);
    
    void handleRespawn(final ClientboundRespawnPacket ob);
    
    void handleRotateMob(final ClientboundRotateHeadPacket oc);
    
    void handleSetCarriedItem(final ClientboundSetCarriedItemPacket og);
    
    void handleSetDisplayObjective(final ClientboundSetDisplayObjectivePacket oj);
    
    void handleSetEntityData(final ClientboundSetEntityDataPacket ok);
    
    void handleSetEntityMotion(final ClientboundSetEntityMotionPacket om);
    
    void handleSetEquippedItem(final ClientboundSetEquippedItemPacket on);
    
    void handleSetExperience(final ClientboundSetExperiencePacket oo);
    
    void handleSetHealth(final ClientboundSetHealthPacket op);
    
    void handleSetPlayerTeamPacket(final ClientboundSetPlayerTeamPacket os);
    
    void handleSetScore(final ClientboundSetScorePacket ot);
    
    void handleSetSpawn(final ClientboundSetSpawnPositionPacket ou);
    
    void handleSetTime(final ClientboundSetTimePacket ov);
    
    void handleSoundEvent(final ClientboundSoundPacket oy);
    
    void handleSoundEntityEvent(final ClientboundSoundEntityPacket ox);
    
    void handleCustomSoundEvent(final ClientboundCustomSoundPacket mx);
    
    void handleTakeItemEntity(final ClientboundTakeItemEntityPacket pc);
    
    void handleTeleportEntity(final ClientboundTeleportEntityPacket pd);
    
    void handleUpdateAttributes(final ClientboundUpdateAttributesPacket pf);
    
    void handleUpdateMobEffect(final ClientboundUpdateMobEffectPacket pg);
    
    void handleUpdateTags(final ClientboundUpdateTagsPacket pi);
    
    void handlePlayerCombat(final ClientboundPlayerCombatPacket nt);
    
    void handleChangeDifficulty(final ClientboundChangeDifficultyPacket ml);
    
    void handleSetCamera(final ClientboundSetCameraPacket of);
    
    void handleSetBorder(final ClientboundSetBorderPacket oe);
    
    void handleSetTitles(final ClientboundSetTitlesPacket ow);
    
    void handleTabListCustomisation(final ClientboundTabListPacket pa);
    
    void handleResourcePack(final ClientboundResourcePackPacket oa);
    
    void handleBossUpdate(final ClientboundBossEventPacket mk);
    
    void handleItemCooldown(final ClientboundCooldownPacket mv);
    
    void handleMoveVehicle(final ClientboundMoveVehiclePacket nn);
    
    void handleUpdateAdvancementsPacket(final ClientboundUpdateAdvancementsPacket pe);
    
    void handleSelectAdvancementsTab(final ClientboundSelectAdvancementsTabPacket od);
    
    void handlePlaceRecipe(final ClientboundPlaceGhostRecipePacket nr);
    
    void handleCommands(final ClientboundCommandsPacket mp);
    
    void handleStopSoundEvent(final ClientboundStopSoundPacket oz);
    
    void handleCommandSuggestions(final ClientboundCommandSuggestionsPacket mo);
    
    void handleUpdateRecipes(final ClientboundUpdateRecipesPacket ph);
    
    void handleLookAt(final ClientboundPlayerLookAtPacket nv);
    
    void handleTagQueryPacket(final ClientboundTagQueryPacket pb);
    
    void handleLightUpdatePacked(final ClientboundLightUpdatePacket ni);
    
    void handleOpenBook(final ClientboundOpenBookPacket no);
    
    void handleOpenScreen(final ClientboundOpenScreenPacket np);
    
    void handleMerchantOffers(final ClientboundMerchantOffersPacket nl);
    
    void handleSetChunkCacheRadius(final ClientboundSetChunkCacheRadiusPacket oi);
    
    void handleSetChunkCacheCenter(final ClientboundSetChunkCacheCenterPacket oh);
    
    void handleBlockBreakAck(final ClientboundBlockBreakAckPacket mf);
}
