package net.minecraft.network.protocol.game;

import org.apache.logging.log4j.LogManager;
import java.util.Iterator;
import net.minecraft.network.protocol.Packet;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.entity.player.Player;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.level.block.entity.BeehiveBlockEntity;
import net.minecraft.world.entity.animal.Bee;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.raid.Raid;
import java.util.Collection;
import net.minecraft.world.entity.ai.goal.GoalSelector;
import net.minecraft.world.level.levelgen.structure.StructureStart;
import net.minecraft.world.level.LevelAccessor;
import javax.annotation.Nullable;
import net.minecraft.world.level.pathfinder.Path;
import net.minecraft.world.entity.Mob;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.ChunkPos;
import net.minecraft.network.FriendlyByteBuf;
import io.netty.buffer.Unpooled;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;
import org.apache.logging.log4j.Logger;

public class DebugPackets {
    private static final Logger LOGGER;
    
    public static void sendGameTestAddMarker(final ServerLevel xd, final BlockPos fk, final String string, final int integer4, final int integer5) {
        final FriendlyByteBuf kv6 = new FriendlyByteBuf(Unpooled.buffer());
        kv6.writeBlockPos(fk);
        kv6.writeInt(integer4);
        kv6.writeUtf(string);
        kv6.writeInt(integer5);
        sendPacketToAllPlayers(xd, kv6, ClientboundCustomPayloadPacket.DEBUG_GAME_TEST_ADD_MARKER);
    }
    
    public static void sendGameTestClearPacket(final ServerLevel xd) {
        final FriendlyByteBuf kv2 = new FriendlyByteBuf(Unpooled.buffer());
        sendPacketToAllPlayers(xd, kv2, ClientboundCustomPayloadPacket.DEBUG_GAME_TEST_CLEAR);
    }
    
    public static void sendPoiPacketsForChunk(final ServerLevel xd, final ChunkPos bje) {
    }
    
    public static void sendPoiAddedPacket(final ServerLevel xd, final BlockPos fk) {
    }
    
    public static void sendPoiRemovedPacket(final ServerLevel xd, final BlockPos fk) {
    }
    
    public static void sendPoiTicketCountPacket(final ServerLevel xd, final BlockPos fk) {
    }
    
    public static void sendPathFindingPacket(final Level bjt, final Mob akx, @Nullable final Path cqn, final float float4) {
    }
    
    public static void sendNeighborsUpdatePacket(final Level bjt, final BlockPos fk) {
    }
    
    public static void sendStructurePacket(final LevelAccessor bju, final StructureStart cls) {
    }
    
    public static void sendGoalSelector(final Level bjt, final Mob akx, final GoalSelector ape) {
    }
    
    public static void sendRaids(final ServerLevel xd, final Collection<Raid> collection) {
    }
    
    public static void sendEntityBrain(final LivingEntity akw) {
    }
    
    public static void sendBeeInfo(final Bee ata) {
    }
    
    public static void sendHiveInfo(final BeehiveBlockEntity bwf) {
    }
    
    private static void sendPacketToAllPlayers(final ServerLevel xd, final FriendlyByteBuf kv, final ResourceLocation sm) {
        final Packet<?> lt4 = new ClientboundCustomPayloadPacket(sm, kv);
        for (final Player ayg6 : xd.getLevel().players()) {
            ((ServerPlayer)ayg6).connection.send(lt4);
        }
    }
    
    static {
        LOGGER = LogManager.getLogger();
    }
}
