package net.minecraft.network.protocol.game;

import net.minecraft.network.PacketListener;
import java.io.IOException;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.world.entity.Entity;
import net.minecraft.network.protocol.Packet;

public class ServerboundMoveVehiclePacket implements Packet<ServerGamePacketListener> {
    private double x;
    private double y;
    private double z;
    private float yRot;
    private float xRot;
    
    public ServerboundMoveVehiclePacket() {
    }
    
    public ServerboundMoveVehiclePacket(final Entity akn) {
        this.x = akn.getX();
        this.y = akn.getY();
        this.z = akn.getZ();
        this.yRot = akn.yRot;
        this.xRot = akn.xRot;
    }
    
    @Override
    public void read(final FriendlyByteBuf kv) throws IOException {
        this.x = kv.readDouble();
        this.y = kv.readDouble();
        this.z = kv.readDouble();
        this.yRot = kv.readFloat();
        this.xRot = kv.readFloat();
    }
    
    @Override
    public void write(final FriendlyByteBuf kv) throws IOException {
        kv.writeDouble(this.x);
        kv.writeDouble(this.y);
        kv.writeDouble(this.z);
        kv.writeFloat(this.yRot);
        kv.writeFloat(this.xRot);
    }
    
    @Override
    public void handle(final ServerGamePacketListener pl) {
        pl.handleMoveVehicle(this);
    }
    
    public double getX() {
        return this.x;
    }
    
    public double getY() {
        return this.y;
    }
    
    public double getZ() {
        return this.z;
    }
    
    public float getYRot() {
        return this.yRot;
    }
    
    public float getXRot() {
        return this.xRot;
    }
}
