package net.minecraft.server.level.progress;

import javax.annotation.Nullable;
import net.minecraft.world.level.chunk.ChunkStatus;
import net.minecraft.world.level.ChunkPos;
import java.util.concurrent.Executor;
import net.minecraft.util.thread.ProcessorMailbox;

public class ProcessorChunkProgressListener implements ChunkProgressListener {
    private final ChunkProgressListener delegate;
    private final ProcessorMailbox<Runnable> mailbox;
    
    public ProcessorChunkProgressListener(final ChunkProgressListener xm, final Executor executor) {
        this.delegate = xm;
        this.mailbox = ProcessorMailbox.create(executor, "progressListener");
    }
    
    @Override
    public void updateSpawnPos(final ChunkPos bje) {
        this.mailbox.tell(() -> this.delegate.updateSpawnPos(bje));
    }
    
    @Override
    public void onStatusChange(final ChunkPos bje, @Nullable final ChunkStatus cab) {
        this.mailbox.tell(() -> this.delegate.onStatusChange(bje, cab));
    }
    
    @Override
    public void stop() {
        this.mailbox.tell(this.delegate::stop);
    }
}
