package net.minecraft.world.effect;

import net.minecraft.world.entity.LivingEntity;
import net.minecraft.util.StringUtil;
import net.minecraft.util.Mth;

public final class MobEffectUtil {
    public static String formatDuration(final MobEffectInstance akh, final float float2) {
        if (akh.isNoCounter()) {
            return "**:**";
        }
        final int integer3 = Mth.floor(akh.getDuration() * float2);
        return StringUtil.formatTickDuration(integer3);
    }
    
    public static boolean hasDigSpeed(final LivingEntity akw) {
        return akw.hasEffect(MobEffects.DIG_SPEED) || akw.hasEffect(MobEffects.CONDUIT_POWER);
    }
    
    public static int getDigSpeedAmplification(final LivingEntity akw) {
        int integer2 = 0;
        int integer3 = 0;
        if (akw.hasEffect(MobEffects.DIG_SPEED)) {
            integer2 = akw.getEffect(MobEffects.DIG_SPEED).getAmplifier();
        }
        if (akw.hasEffect(MobEffects.CONDUIT_POWER)) {
            integer3 = akw.getEffect(MobEffects.CONDUIT_POWER).getAmplifier();
        }
        return Math.max(integer2, integer3);
    }
    
    public static boolean hasWaterBreathing(final LivingEntity akw) {
        return akw.hasEffect(MobEffects.WATER_BREATHING) || akw.hasEffect(MobEffects.CONDUIT_POWER);
    }
}
