package net.minecraft.world.entity.ai.behavior;

import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.phys.Vec3;
import net.minecraft.core.BlockPos;

public class BlockPosWrapper implements PositionWrapper {
    private final BlockPos pos;
    private final Vec3 lookAt;
    
    public BlockPosWrapper(final BlockPos fk) {
        this.pos = fk;
        this.lookAt = new Vec3(fk.getX() + 0.5, fk.getY() + 0.5, fk.getZ() + 0.5);
    }
    
    @Override
    public BlockPos getPos() {
        return this.pos;
    }
    
    @Override
    public Vec3 getLookAtPos() {
        return this.lookAt;
    }
    
    @Override
    public boolean isVisible(final LivingEntity akw) {
        return true;
    }
    
    @Override
    public String toString() {
        return "BlockPosWrapper{pos=" + this.pos + ", lookAt=" + this.lookAt + '}';
    }
}
