package net.minecraft.world.entity.ai.behavior;

import net.minecraft.world.entity.LivingEntity;
import net.minecraft.server.level.ServerLevel;
import java.util.Map;
import com.google.common.collect.ImmutableMap;
import net.minecraft.world.entity.ai.memory.MemoryStatus;
import net.minecraft.world.entity.ai.memory.MemoryModuleType;
import net.minecraft.world.entity.Mob;

public class LookAtTargetSink extends Behavior<Mob> {
    public LookAtTargetSink(final int integer1, final int integer2) {
        super(ImmutableMap.<MemoryModuleType<PositionWrapper>, MemoryStatus>of(MemoryModuleType.LOOK_TARGET, MemoryStatus.VALUE_PRESENT), integer1, integer2);
    }
    
    @Override
    protected boolean canStillUse(final ServerLevel xd, final Mob akx, final long long3) {
        return akx.getBrain().<PositionWrapper>getMemory(MemoryModuleType.LOOK_TARGET).filter(amw -> amw.isVisible(akx)).isPresent();
    }
    
    @Override
    protected void stop(final ServerLevel xd, final Mob akx, final long long3) {
        akx.getBrain().<PositionWrapper>eraseMemory(MemoryModuleType.LOOK_TARGET);
    }
    
    @Override
    protected void tick(final ServerLevel xd, final Mob akx, final long long3) {
        akx.getBrain().<PositionWrapper>getMemory(MemoryModuleType.LOOK_TARGET).ifPresent(amw -> akx.getLookControl().setLookAt(amw.getLookAtPos()));
    }
}
