package net.minecraft.world.entity.ai.behavior;

import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.npc.VillagerData;
import net.minecraft.world.entity.npc.VillagerProfession;
import net.minecraft.server.level.ServerLevel;
import java.util.Map;
import net.minecraft.core.GlobalPos;
import com.google.common.collect.ImmutableMap;
import net.minecraft.world.entity.ai.memory.MemoryStatus;
import net.minecraft.world.entity.ai.memory.MemoryModuleType;
import net.minecraft.world.entity.npc.Villager;

public class ResetProfession extends Behavior<Villager> {
    public ResetProfession() {
        super(ImmutableMap.<MemoryModuleType<GlobalPos>, MemoryStatus>of(MemoryModuleType.JOB_SITE, MemoryStatus.VALUE_ABSENT));
    }
    
    @Override
    protected boolean checkExtraStartConditions(final ServerLevel xd, final Villager axt) {
        final VillagerData axu4 = axt.getVillagerData();
        return axu4.getProfession() != VillagerProfession.NONE && axu4.getProfession() != VillagerProfession.NITWIT && axt.getVillagerXp() == 0 && axu4.getLevel() <= 1;
    }
    
    @Override
    protected void start(final ServerLevel xd, final Villager axt, final long long3) {
        axt.setVillagerData(axt.getVillagerData().setProfession(VillagerProfession.NONE));
        axt.refreshBrain(xd);
    }
}
