package net.minecraft.world.entity.ai.behavior;

import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.entity.ai.Brain;
import net.minecraft.core.Direction;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.BellBlock;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.core.Vec3i;
import net.minecraft.world.entity.Entity;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;
import java.util.Map;
import net.minecraft.core.GlobalPos;
import com.google.common.collect.ImmutableMap;
import net.minecraft.world.entity.ai.memory.MemoryStatus;
import net.minecraft.world.entity.ai.memory.MemoryModuleType;
import net.minecraft.world.entity.LivingEntity;

public class RingBell extends Behavior<LivingEntity> {
    public RingBell() {
        super(ImmutableMap.<MemoryModuleType<GlobalPos>, MemoryStatus>of(MemoryModuleType.MEETING_POINT, MemoryStatus.VALUE_PRESENT));
    }
    
    @Override
    protected boolean checkExtraStartConditions(final ServerLevel xd, final LivingEntity akw) {
        return xd.random.nextFloat() > 0.95f;
    }
    
    @Override
    protected void start(final ServerLevel xd, final LivingEntity akw, final long long3) {
        final Brain<?> alm6 = akw.getBrain();
        final BlockPos fk7 = alm6.<GlobalPos>getMemory(MemoryModuleType.MEETING_POINT).get().pos();
        if (fk7.closerThan(new BlockPos(akw), 3.0)) {
            final BlockState byg8 = xd.getBlockState(fk7);
            if (byg8.getBlock() == Blocks.BELL) {
                final BellBlock bpc9 = (BellBlock)byg8.getBlock();
                bpc9.attemptToRing(xd, fk7, null);
            }
        }
    }
}
