package net.minecraft.world.entity.ai.behavior;

import net.minecraft.world.entity.raid.Raid;
import net.minecraft.world.entity.ai.Brain;
import net.minecraft.world.entity.schedule.Activity;
import net.minecraft.world.entity.Entity;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;
import java.util.Map;
import com.google.common.collect.ImmutableMap;
import net.minecraft.world.entity.LivingEntity;

public class SetRaidStatus extends Behavior<LivingEntity> {
    public SetRaidStatus() {
        super(ImmutableMap.of());
    }
    
    @Override
    protected boolean checkExtraStartConditions(final ServerLevel xd, final LivingEntity akw) {
        return xd.random.nextInt(20) == 0;
    }
    
    @Override
    protected void start(final ServerLevel xd, final LivingEntity akw, final long long3) {
        final Brain<?> alm6 = akw.getBrain();
        final Raid azk7 = xd.getRaidAt(new BlockPos(akw));
        if (azk7 != null) {
            if (!azk7.hasFirstWaveSpawned() || azk7.isBetweenWaves()) {
                alm6.setDefaultActivity(Activity.PRE_RAID);
                alm6.setActivity(Activity.PRE_RAID);
            }
            else {
                alm6.setDefaultActivity(Activity.RAID);
                alm6.setActivity(Activity.RAID);
            }
        }
    }
}
