package net.minecraft.world.entity.ai.behavior;

import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.phys.Vec3;
import net.minecraft.world.entity.ai.util.RandomPos;
import net.minecraft.server.level.ServerLevel;
import java.util.Map;
import net.minecraft.world.entity.ai.memory.WalkTarget;
import com.google.common.collect.ImmutableMap;
import net.minecraft.world.entity.ai.memory.MemoryStatus;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.ai.memory.MemoryModuleType;
import net.minecraft.world.entity.PathfinderMob;

public class SetWalkTargetAwayFromEntity extends Behavior<PathfinderMob> {
    private final MemoryModuleType<? extends Entity> memory;
    private final float speed;
    
    public SetWalkTargetAwayFromEntity(final MemoryModuleType<? extends Entity> ari, final float float2) {
        super(ImmutableMap.<MemoryModuleType<WalkTarget>, MemoryStatus>of(MemoryModuleType.WALK_TARGET, MemoryStatus.VALUE_ABSENT, (MemoryModuleType<WalkTarget>)ari, MemoryStatus.VALUE_PRESENT));
        this.memory = ari;
        this.speed = float2;
    }
    
    @Override
    protected boolean checkExtraStartConditions(final ServerLevel xd, final PathfinderMob ald) {
        final Entity akn4 = (Entity)ald.getBrain().getMemory(this.memory).get();
        return ald.distanceToSqr(akn4) < 36.0;
    }
    
    @Override
    protected void start(final ServerLevel xd, final PathfinderMob ald, final long long3) {
        final Entity akn6 = (Entity)ald.getBrain().getMemory(this.memory).get();
        moveAwayFromMob(ald, akn6, this.speed);
    }
    
    public static void moveAwayFromMob(final PathfinderMob ald, final Entity akn, final float float3) {
        for (int integer4 = 0; integer4 < 10; ++integer4) {
            final Vec3 cvi5 = RandomPos.getLandPosAvoid(ald, 16, 7, akn.position());
            if (cvi5 != null) {
                ald.getBrain().<WalkTarget>setMemory(MemoryModuleType.WALK_TARGET, new WalkTarget(cvi5, float3, 0));
                return;
            }
        }
    }
}
