package net.minecraft.world.entity.ai.behavior;

import net.minecraft.world.entity.LivingEntity;
import net.minecraft.server.level.ServerLevel;
import java.util.Map;
import com.google.common.collect.ImmutableMap;
import net.minecraft.world.entity.Mob;

public class Swim extends Behavior<Mob> {
    private final float height;
    private final float chance;
    
    public Swim(final float float1, final float float2) {
        super(ImmutableMap.of());
        this.height = float1;
        this.chance = float2;
    }
    
    @Override
    protected boolean checkExtraStartConditions(final ServerLevel xd, final Mob akx) {
        return (akx.isInWater() && akx.getWaterHeight() > this.height) || akx.isInLava();
    }
    
    @Override
    protected boolean canStillUse(final ServerLevel xd, final Mob akx, final long long3) {
        return this.checkExtraStartConditions(xd, akx);
    }
    
    @Override
    protected void tick(final ServerLevel xd, final Mob akx, final long long3) {
        if (akx.getRandom().nextFloat() < this.chance) {
            akx.getJumpControl().jump();
        }
    }
}
