package net.minecraft.world.entity.ai.sensing;

import com.google.common.collect.ImmutableSet;
import java.util.Set;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.ai.Brain;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.ai.memory.MemoryModuleType;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.entity.LivingEntity;

public class HurtBySensor extends Sensor<LivingEntity> {
    @Override
    protected void doTick(final ServerLevel xd, final LivingEntity akw) {
        final Brain<?> alm4 = akw.getBrain();
        if (akw.getLastDamageSource() != null) {
            alm4.<DamageSource>setMemory(MemoryModuleType.HURT_BY, akw.getLastDamageSource());
            final Entity akn5 = alm4.<DamageSource>getMemory(MemoryModuleType.HURT_BY).get().getEntity();
            if (akn5 instanceof LivingEntity) {
                alm4.<LivingEntity>setMemory(MemoryModuleType.HURT_BY_ENTITY, (LivingEntity)akn5);
            }
        }
        else {
            alm4.<DamageSource>eraseMemory(MemoryModuleType.HURT_BY);
        }
    }
    
    @Override
    public Set<MemoryModuleType<?>> requires() {
        return ImmutableSet.of(MemoryModuleType.HURT_BY, (MemoryModuleType<DamageSource>)MemoryModuleType.HURT_BY_ENTITY);
    }
}
