package net.minecraft.world.entity.animal.horse;

import net.minecraft.world.entity.AgableMob;
import net.minecraft.world.entity.animal.Animal;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.EntityType;

public class Donkey extends AbstractChestedHorse {
    public Donkey(final EntityType<? extends Donkey> akr, final Level bjt) {
        super(akr, bjt);
    }
    
    @Override
    protected SoundEvent getAmbientSound() {
        super.getAmbientSound();
        return SoundEvents.DONKEY_AMBIENT;
    }
    
    @Override
    protected SoundEvent getDeathSound() {
        super.getDeathSound();
        return SoundEvents.DONKEY_DEATH;
    }
    
    @Override
    protected SoundEvent getHurtSound(final DamageSource ajw) {
        super.getHurtSound(ajw);
        return SoundEvents.DONKEY_HURT;
    }
    
    @Override
    public boolean canMate(final Animal asz) {
        return asz != this && (asz instanceof Donkey || asz instanceof Horse) && this.canParent() && ((AbstractHorse)asz).canParent();
    }
    
    @Override
    public AgableMob getBreedOffspring(final AgableMob akl) {
        final EntityType<? extends AbstractHorse> akr3 = (akl instanceof Horse) ? EntityType.MULE : EntityType.DONKEY;
        final AbstractHorse aub4 = (AbstractHorse)akr3.create(this.level);
        this.setOffspringAttributes(akl, aub4);
        return aub4;
    }
}
