package net.minecraft.world.entity.boss;

import net.minecraft.world.entity.Pose;
import net.minecraft.network.protocol.Packet;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.entity.EntityDimensions;
import net.minecraft.world.entity.boss.enderdragon.EnderDragon;
import net.minecraft.world.entity.Entity;

public class EnderDragonPart extends Entity {
    public final EnderDragon parentMob;
    public final String name;
    private final EntityDimensions size;
    
    public EnderDragonPart(final EnderDragon aup, final String string, final float float3, final float float4) {
        super(aup.getType(), aup.level);
        this.size = EntityDimensions.scalable(float3, float4);
        this.refreshDimensions();
        this.parentMob = aup;
        this.name = string;
    }
    
    @Override
    protected void defineSynchedData() {
    }
    
    @Override
    protected void readAdditionalSaveData(final CompoundTag jt) {
    }
    
    @Override
    protected void addAdditionalSaveData(final CompoundTag jt) {
    }
    
    @Override
    public boolean isPickable() {
        return true;
    }
    
    @Override
    public boolean hurt(final DamageSource ajw, final float float2) {
        return !this.isInvulnerableTo(ajw) && this.parentMob.hurt(this, ajw, float2);
    }
    
    @Override
    public boolean is(final Entity akn) {
        return this == akn || this.parentMob == akn;
    }
    
    @Override
    public Packet<?> getAddEntityPacket() {
        throw new UnsupportedOperationException();
    }
    
    @Override
    public EntityDimensions getDimensions(final Pose alg) {
        return this.size;
    }
}
