package net.minecraft.world.entity.boss.enderdragon.phases;

import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.boss.enderdragon.EnderDragon;

public abstract class AbstractDragonSittingPhase extends AbstractDragonPhaseInstance {
    public AbstractDragonSittingPhase(final EnderDragon aup) {
        super(aup);
    }
    
    @Override
    public boolean isSitting() {
        return true;
    }
    
    @Override
    public float onHurt(final DamageSource ajw, final float float2) {
        if (ajw.getDirectEntity() instanceof AbstractArrow) {
            ajw.getDirectEntity().setSecondsOnFire(1);
            return 0.0f;
        }
        return super.onHurt(ajw, float2);
    }
}
