package net.minecraft.world.entity.monster;

import net.minecraft.world.entity.Entity;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.Items;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.EntityType;

public class Skeleton extends AbstractSkeleton {
    public Skeleton(final EntityType<? extends Skeleton> akr, final Level bjt) {
        super(akr, bjt);
    }
    
    @Override
    protected SoundEvent getAmbientSound() {
        return SoundEvents.SKELETON_AMBIENT;
    }
    
    @Override
    protected SoundEvent getHurtSound(final DamageSource ajw) {
        return SoundEvents.SKELETON_HURT;
    }
    
    @Override
    protected SoundEvent getDeathSound() {
        return SoundEvents.SKELETON_DEATH;
    }
    
    @Override
    SoundEvent getStepSound() {
        return SoundEvents.SKELETON_STEP;
    }
    
    @Override
    protected void dropCustomDeathLoot(final DamageSource ajw, final int integer, final boolean boolean3) {
        super.dropCustomDeathLoot(ajw, integer, boolean3);
        final Entity akn5 = ajw.getEntity();
        if (akn5 instanceof Creeper) {
            final Creeper awf6 = (Creeper)akn5;
            if (awf6.canDropMobsSkull()) {
                awf6.increaseDroppedSkulls();
                this.spawnAtLocation(Items.SKELETON_SKULL);
            }
        }
    }
}
