package net.minecraft.world.entity.projectile;

import net.minecraft.world.entity.Entity;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.monster.Blaze;
import net.minecraft.world.phys.EntityHitResult;
import net.minecraft.world.phys.HitResult;
import net.minecraft.world.item.ItemStack;
import net.minecraft.core.particles.ItemParticleOption;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.core.particles.ParticleOptions;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.Item;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.EntityType;

public class Snowball extends ThrowableItemProjectile {
    public Snowball(final EntityType<? extends Snowball> akr, final Level bjt) {
        super(akr, bjt);
    }
    
    public Snowball(final Level bjt, final LivingEntity akw) {
        super(EntityType.SNOWBALL, akw, bjt);
    }
    
    public Snowball(final Level bjt, final double double2, final double double3, final double double4) {
        super(EntityType.SNOWBALL, double2, double3, double4, bjt);
    }
    
    @Override
    protected Item getDefaultItem() {
        return Items.SNOWBALL;
    }
    
    private ParticleOptions getParticle() {
        final ItemStack bek2 = this.getItemRaw();
        return bek2.isEmpty() ? ParticleTypes.ITEM_SNOWBALL : new ItemParticleOption(ParticleTypes.ITEM, bek2);
    }
    
    @Override
    public void handleEntityEvent(final byte byte1) {
        if (byte1 == 3) {
            final ParticleOptions gt3 = this.getParticle();
            for (int integer4 = 0; integer4 < 8; ++integer4) {
                this.level.addParticle(gt3, this.getX(), this.getY(), this.getZ(), 0.0, 0.0, 0.0);
            }
        }
    }
    
    @Override
    protected void onHit(final HitResult cvf) {
        if (cvf.getType() == HitResult.Type.ENTITY) {
            final Entity akn3 = ((EntityHitResult)cvf).getEntity();
            final int integer4 = (akn3 instanceof Blaze) ? 3 : 0;
            akn3.hurt(DamageSource.thrown(this, this.getOwner()), (float)integer4);
        }
        if (!this.level.isClientSide) {
            this.level.broadcastEntityEvent(this, (byte)3);
            this.remove();
        }
    }
}
