package net.minecraft.world.entity.vehicle;

import net.minecraft.world.entity.Entity;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.EntityType;

public class Minecart extends AbstractMinecart {
    public Minecart(final EntityType<?> akr, final Level bjt) {
        super(akr, bjt);
    }
    
    public Minecart(final Level bjt, final double double2, final double double3, final double double4) {
        super(EntityType.MINECART, bjt, double2, double3, double4);
    }
    
    @Override
    public boolean interact(final Player ayg, final InteractionHand ajh) {
        if (ayg.isSecondaryUseActive()) {
            return false;
        }
        if (this.isVehicle()) {
            return true;
        }
        if (!this.level.isClientSide) {
            ayg.startRiding(this);
        }
        return true;
    }
    
    @Override
    public void activateMinecart(final int integer1, final int integer2, final int integer3, final boolean boolean4) {
        if (boolean4) {
            if (this.isVehicle()) {
                this.ejectPassengers();
            }
            if (this.getHurtTime() == 0) {
                this.setHurtDir(-this.getHurtDir());
                this.setHurtTime(10);
                this.setDamage(50.0f);
                this.markHurt();
            }
        }
    }
    
    @Override
    public Type getMinecartType() {
        return Type.RIDEABLE;
    }
}
