package net.minecraft.world.inventory;

import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.Container;

public class DispenserMenu extends AbstractContainerMenu {
    private final Container dispenser;
    
    public DispenserMenu(final int integer, final Inventory ayf) {
        this(integer, ayf, new SimpleContainer(9));
    }
    
    public DispenserMenu(final int integer, final Inventory ayf, final Container ajb) {
        super(MenuType.GENERIC_3x3, integer);
        AbstractContainerMenu.checkContainerSize(ajb, 9);
        (this.dispenser = ajb).startOpen(ayf.player);
        for (int integer2 = 0; integer2 < 3; ++integer2) {
            for (int integer3 = 0; integer3 < 3; ++integer3) {
                this.addSlot(new Slot(ajb, integer3 + integer2 * 3, 62 + integer3 * 18, 17 + integer2 * 18));
            }
        }
        for (int integer2 = 0; integer2 < 3; ++integer2) {
            for (int integer3 = 0; integer3 < 9; ++integer3) {
                this.addSlot(new Slot(ayf, integer3 + integer2 * 9 + 9, 8 + integer3 * 18, 84 + integer2 * 18));
            }
        }
        for (int integer2 = 0; integer2 < 9; ++integer2) {
            this.addSlot(new Slot(ayf, integer2, 8 + integer2 * 18, 142));
        }
    }
    
    @Override
    public boolean stillValid(final Player ayg) {
        return this.dispenser.stillValid(ayg);
    }
    
    @Override
    public ItemStack quickMoveStack(final Player ayg, final int integer) {
        ItemStack bek4 = ItemStack.EMPTY;
        final Slot bbx5 = this.slots.get(integer);
        if (bbx5 != null && bbx5.hasItem()) {
            final ItemStack bek5 = bbx5.getItem();
            bek4 = bek5.copy();
            if (integer < 9) {
                if (!this.moveItemStackTo(bek5, 9, 45, true)) {
                    return ItemStack.EMPTY;
                }
            }
            else if (!this.moveItemStackTo(bek5, 0, 9, false)) {
                return ItemStack.EMPTY;
            }
            if (bek5.isEmpty()) {
                bbx5.set(ItemStack.EMPTY);
            }
            else {
                bbx5.setChanged();
            }
            if (bek5.getCount() == bek4.getCount()) {
                return ItemStack.EMPTY;
            }
            bbx5.onTake(ayg, bek5);
        }
        return bek4;
    }
    
    @Override
    public void removed(final Player ayg) {
        super.removed(ayg);
        this.dispenser.stopOpen(ayg);
    }
}
