package net.minecraft.world.inventory;

import net.minecraft.world.item.Items;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.Container;

public class FurnaceFuelSlot extends Slot {
    private final AbstractFurnaceMenu menu;
    
    public FurnaceFuelSlot(final AbstractFurnaceMenu bal, final Container ajb, final int integer3, final int integer4, final int integer5) {
        super(ajb, integer3, integer4, integer5);
        this.menu = bal;
    }
    
    @Override
    public boolean mayPlace(final ItemStack bek) {
        return this.menu.isFuel(bek) || isBucket(bek);
    }
    
    @Override
    public int getMaxStackSize(final ItemStack bek) {
        return isBucket(bek) ? 1 : super.getMaxStackSize(bek);
    }
    
    public static boolean isBucket(final ItemStack bek) {
        return bek.getItem() == Items.BUCKET;
    }
}
