package net.minecraft.world.inventory;

import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.Container;

public class HopperMenu extends AbstractContainerMenu {
    private final Container hopper;
    
    public HopperMenu(final int integer, final Inventory ayf) {
        this(integer, ayf, new SimpleContainer(5));
    }
    
    public HopperMenu(final int integer, final Inventory ayf, final Container ajb) {
        super(MenuType.HOPPER, integer);
        AbstractContainerMenu.checkContainerSize(this.hopper = ajb, 5);
        ajb.startOpen(ayf.player);
        final int integer2 = 51;
        for (int integer3 = 0; integer3 < 5; ++integer3) {
            this.addSlot(new Slot(ajb, integer3, 44 + integer3 * 18, 20));
        }
        for (int integer3 = 0; integer3 < 3; ++integer3) {
            for (int integer4 = 0; integer4 < 9; ++integer4) {
                this.addSlot(new Slot(ayf, integer4 + integer3 * 9 + 9, 8 + integer4 * 18, integer3 * 18 + 51));
            }
        }
        for (int integer3 = 0; integer3 < 9; ++integer3) {
            this.addSlot(new Slot(ayf, integer3, 8 + integer3 * 18, 109));
        }
    }
    
    @Override
    public boolean stillValid(final Player ayg) {
        return this.hopper.stillValid(ayg);
    }
    
    @Override
    public ItemStack quickMoveStack(final Player ayg, final int integer) {
        ItemStack bek4 = ItemStack.EMPTY;
        final Slot bbx5 = this.slots.get(integer);
        if (bbx5 != null && bbx5.hasItem()) {
            final ItemStack bek5 = bbx5.getItem();
            bek4 = bek5.copy();
            if (integer < this.hopper.getContainerSize()) {
                if (!this.moveItemStackTo(bek5, this.hopper.getContainerSize(), this.slots.size(), true)) {
                    return ItemStack.EMPTY;
                }
            }
            else if (!this.moveItemStackTo(bek5, 0, this.hopper.getContainerSize(), false)) {
                return ItemStack.EMPTY;
            }
            if (bek5.isEmpty()) {
                bbx5.set(ItemStack.EMPTY);
            }
            else {
                bbx5.setChanged();
            }
        }
        return bek4;
    }
    
    @Override
    public void removed(final Player ayg) {
        super.removed(ayg);
        this.hopper.stopOpen(ayg);
    }
}
