package net.minecraft.world.inventory;

import net.minecraft.world.level.GameRules;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.level.Level;
import java.util.Collection;
import java.util.Collections;
import net.minecraft.world.entity.player.Player;
import javax.annotation.Nullable;
import net.minecraft.world.item.crafting.Recipe;

public interface RecipeHolder {
    void setRecipeUsed(@Nullable final Recipe<?> bgt);
    
    @Nullable
    Recipe<?> getRecipeUsed();
    
    default void awardAndReset(final Player ayg) {
        final Recipe<?> bgt3 = this.getRecipeUsed();
        if (bgt3 != null && !bgt3.isSpecial()) {
            ayg.awardRecipes(Collections.<Recipe<?>>singleton(bgt3));
            this.setRecipeUsed(null);
        }
    }
    
    default boolean setRecipeUsed(final Level bjt, final ServerPlayer xe, final Recipe<?> bgt) {
        if (bgt.isSpecial() || !bjt.getGameRules().getBoolean(GameRules.RULE_LIMITED_CRAFTING) || xe.getRecipeBook().contains(bgt)) {
            this.setRecipeUsed(bgt);
            return true;
        }
        return false;
    }
}
