package net.minecraft.world.inventory;

import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.Container;

public class ShulkerBoxMenu extends AbstractContainerMenu {
    private final Container container;
    
    public ShulkerBoxMenu(final int integer, final Inventory ayf) {
        this(integer, ayf, new SimpleContainer(27));
    }
    
    public ShulkerBoxMenu(final int integer, final Inventory ayf, final Container ajb) {
        super(MenuType.SHULKER_BOX, integer);
        AbstractContainerMenu.checkContainerSize(ajb, 27);
        (this.container = ajb).startOpen(ayf.player);
        final int integer2 = 3;
        final int integer3 = 9;
        for (int integer4 = 0; integer4 < 3; ++integer4) {
            for (int integer5 = 0; integer5 < 9; ++integer5) {
                this.addSlot(new ShulkerBoxSlot(ajb, integer5 + integer4 * 9, 8 + integer5 * 18, 18 + integer4 * 18));
            }
        }
        for (int integer4 = 0; integer4 < 3; ++integer4) {
            for (int integer5 = 0; integer5 < 9; ++integer5) {
                this.addSlot(new Slot(ayf, integer5 + integer4 * 9 + 9, 8 + integer5 * 18, 84 + integer4 * 18));
            }
        }
        for (int integer4 = 0; integer4 < 9; ++integer4) {
            this.addSlot(new Slot(ayf, integer4, 8 + integer4 * 18, 142));
        }
    }
    
    @Override
    public boolean stillValid(final Player ayg) {
        return this.container.stillValid(ayg);
    }
    
    @Override
    public ItemStack quickMoveStack(final Player ayg, final int integer) {
        ItemStack bek4 = ItemStack.EMPTY;
        final Slot bbx5 = this.slots.get(integer);
        if (bbx5 != null && bbx5.hasItem()) {
            final ItemStack bek5 = bbx5.getItem();
            bek4 = bek5.copy();
            if (integer < this.container.getContainerSize()) {
                if (!this.moveItemStackTo(bek5, this.container.getContainerSize(), this.slots.size(), true)) {
                    return ItemStack.EMPTY;
                }
            }
            else if (!this.moveItemStackTo(bek5, 0, this.container.getContainerSize(), false)) {
                return ItemStack.EMPTY;
            }
            if (bek5.isEmpty()) {
                bbx5.set(ItemStack.EMPTY);
            }
            else {
                bbx5.setChanged();
            }
        }
        return bek4;
    }
    
    @Override
    public void removed(final Player ayg) {
        super.removed(ayg);
        this.container.stopOpen(ayg);
    }
}
