package net.minecraft.world.item;

import net.minecraft.core.BlockPos;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.util.Mth;
import net.minecraft.world.entity.decoration.ItemFrame;
import net.minecraft.world.entity.LivingEntity;
import javax.annotation.Nullable;
import net.minecraft.world.level.Level;
import net.minecraft.resources.ResourceLocation;

public class CompassItem extends Item {
    public CompassItem(final Properties a) {
        super(a);
        this.addProperty(new ResourceLocation("angle"), new ItemPropertyFunction() {
            private double rotation;
            private double rota;
            private long lastUpdateTick;
            
            @Override
            public float call(final ItemStack bek, @Nullable Level bjt, @Nullable final LivingEntity akw) {
                if (akw == null && !bek.isFramed()) {
                    return 0.0f;
                }
                final boolean boolean5 = akw != null;
                final Entity akn6 = boolean5 ? akw : bek.getFrame();
                if (bjt == null) {
                    bjt = akn6.level;
                }
                double double11;
                if (bjt.dimension.isNaturalDimension()) {
                    double double9 = boolean5 ? akn6.yRot : this.getFrameRotation((ItemFrame)akn6);
                    double9 = Mth.positiveModulo(double9 / 360.0, 1.0);
                    final double double10 = this.getSpawnToAngle(bjt, akn6) / 6.2831854820251465;
                    double11 = 0.5 - (double9 - 0.25 - double10);
                }
                else {
                    double11 = Math.random();
                }
                if (boolean5) {
                    double11 = this.wobble(bjt, double11);
                }
                return Mth.positiveModulo((float)double11, 1.0f);
            }
            
            private double wobble(final Level bjt, final double double2) {
                if (bjt.getGameTime() != this.lastUpdateTick) {
                    this.lastUpdateTick = bjt.getGameTime();
                    double double3 = double2 - this.rotation;
                    double3 = Mth.positiveModulo(double3 + 0.5, 1.0) - 0.5;
                    this.rota += double3 * 0.1;
                    this.rota *= 0.8;
                    this.rotation = Mth.positiveModulo(this.rotation + this.rota, 1.0);
                }
                return this.rotation;
            }
            
            private double getFrameRotation(final ItemFrame avo) {
                return Mth.wrapDegrees(180 + avo.getDirection().get2DDataValue() * 90);
            }
            
            private double getSpawnToAngle(final LevelAccessor bju, final Entity akn) {
                final BlockPos fk4 = bju.getSharedSpawnPos();
                return Math.atan2(fk4.getZ() - akn.getZ(), fk4.getX() - akn.getX());
            }
        });
    }
}
