package net.minecraft.world.item;

import net.minecraft.stats.Stat;
import net.minecraft.stats.Stats;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.projectile.ThrownExperienceBottle;
import net.minecraft.sounds.SoundSource;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.world.InteractionResultHolder;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.Level;

public class ExperienceBottleItem extends Item {
    public ExperienceBottleItem(final Properties a) {
        super(a);
    }
    
    @Override
    public boolean isFoil(final ItemStack bek) {
        return true;
    }
    
    @Override
    public InteractionResultHolder<ItemStack> use(final Level bjt, final Player ayg, final InteractionHand ajh) {
        final ItemStack bek5 = ayg.getItemInHand(ajh);
        bjt.playSound(null, ayg.getX(), ayg.getY(), ayg.getZ(), SoundEvents.EXPERIENCE_BOTTLE_THROW, SoundSource.NEUTRAL, 0.5f, 0.4f / (ExperienceBottleItem.random.nextFloat() * 0.4f + 0.8f));
        if (!bjt.isClientSide) {
            final ThrownExperienceBottle azf6 = new ThrownExperienceBottle(bjt, ayg);
            azf6.setItem(bek5);
            azf6.shootFromRotation(ayg, ayg.xRot, ayg.yRot, -20.0f, 0.7f, 1.0f);
            bjt.addFreshEntity(azf6);
        }
        ayg.awardStat(Stats.ITEM_USED.get(this));
        if (!ayg.abilities.instabuild) {
            bek5.shrink(1);
        }
        return InteractionResultHolder.<ItemStack>success(bek5);
    }
}
