package net.minecraft.world.item;

import net.minecraft.world.level.block.state.AbstractStateHolder;
import java.util.Iterator;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.level.block.NetherPortalBlock;
import net.minecraft.core.Direction;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.advancements.CriteriaTriggers;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.FireBlock;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.level.block.state.properties.BlockStateProperties;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.sounds.SoundSource;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.world.InteractionResult;

public class FlintAndSteelItem extends Item {
    public FlintAndSteelItem(final Properties a) {
        super(a);
    }
    
    @Override
    public InteractionResult useOn(final UseOnContext bfw) {
        final Player ayg2 = bfw.getPlayer();
        final LevelAccessor bju4 = bfw.getLevel();
        final BlockPos fk5 = bfw.getClickedPos();
        final BlockState byg6 = bju4.getBlockState(fk5);
        if (canLightCampFire(byg6)) {
            bju4.playSound(ayg2, fk5, SoundEvents.FLINTANDSTEEL_USE, SoundSource.BLOCKS, 1.0f, FlintAndSteelItem.random.nextFloat() * 0.4f + 0.8f);
            bju4.setBlock(fk5, ((AbstractStateHolder<O, BlockState>)byg6).<Comparable, Boolean>setValue((Property<Comparable>)BlockStateProperties.LIT, true), 11);
            if (ayg2 != null) {
                bfw.getItemInHand().<Player>hurtAndBreak(1, ayg2, ayg -> ayg.broadcastBreakEvent(bfw.getHand()));
            }
            return InteractionResult.SUCCESS;
        }
        final BlockPos fk6 = fk5.relative(bfw.getClickedFace());
        if (canUse(bju4.getBlockState(fk6), bju4, fk6)) {
            bju4.playSound(ayg2, fk6, SoundEvents.FLINTANDSTEEL_USE, SoundSource.BLOCKS, 1.0f, FlintAndSteelItem.random.nextFloat() * 0.4f + 0.8f);
            final BlockState byg7 = ((FireBlock)Blocks.FIRE).getStateForPlacement(bju4, fk6);
            bju4.setBlock(fk6, byg7, 11);
            final ItemStack bek9 = bfw.getItemInHand();
            if (ayg2 instanceof ServerPlayer) {
                CriteriaTriggers.PLACED_BLOCK.trigger((ServerPlayer)ayg2, fk6, bek9);
                bek9.<Player>hurtAndBreak(1, ayg2, ayg -> ayg.broadcastBreakEvent(bfw.getHand()));
            }
            return InteractionResult.SUCCESS;
        }
        return InteractionResult.FAIL;
    }
    
    public static boolean canLightCampFire(final BlockState byg) {
        return byg.getBlock() == Blocks.CAMPFIRE && !byg.<Boolean>getValue((Property<Boolean>)BlockStateProperties.WATERLOGGED) && !byg.<Boolean>getValue((Property<Boolean>)BlockStateProperties.LIT);
    }
    
    public static boolean canUse(final BlockState byg, final LevelAccessor bju, final BlockPos fk) {
        final BlockState byg2 = ((FireBlock)Blocks.FIRE).getStateForPlacement(bju, fk);
        boolean boolean5 = false;
        for (final Direction fp7 : Direction.Plane.HORIZONTAL) {
            if (bju.getBlockState(fk.relative(fp7)).getBlock() == Blocks.OBSIDIAN && ((NetherPortalBlock)Blocks.NETHER_PORTAL).isPortal(bju, fk) != null) {
                boolean5 = true;
            }
        }
        return byg.isAir() && (byg2.canSurvive(bju, fk) || boolean5);
    }
}
