package net.minecraft.world.item;

import net.minecraft.network.protocol.Packet;
import net.minecraft.network.protocol.game.ClientboundCooldownPacket;
import net.minecraft.server.level.ServerPlayer;

public class ServerItemCooldowns extends ItemCooldowns {
    private final ServerPlayer player;
    
    public ServerItemCooldowns(final ServerPlayer xe) {
        this.player = xe;
    }
    
    @Override
    protected void onCooldownStarted(final Item bef, final int integer) {
        super.onCooldownStarted(bef, integer);
        this.player.connection.send(new ClientboundCooldownPacket(bef, integer));
    }
    
    @Override
    protected void onCooldownEnded(final Item bef) {
        super.onCooldownEnded(bef);
        this.player.connection.send(new ClientboundCooldownPacket(bef, 0));
    }
}
