package net.minecraft.world.item;

import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.tags.BlockTags;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.Level;

public class ShearsItem extends Item {
    public ShearsItem(final Properties a) {
        super(a);
    }
    
    @Override
    public boolean mineBlock(final ItemStack bek, final Level bjt, final BlockState byg, final BlockPos fk, final LivingEntity akw) {
        if (!bjt.isClientSide) {
            bek.<LivingEntity>hurtAndBreak(1, akw, akw -> akw.broadcastBreakEvent(EquipmentSlot.MAINHAND));
        }
        final Block bpe7 = byg.getBlock();
        return byg.is(BlockTags.LEAVES) || bpe7 == Blocks.COBWEB || bpe7 == Blocks.GRASS || bpe7 == Blocks.FERN || bpe7 == Blocks.DEAD_BUSH || bpe7 == Blocks.VINE || bpe7 == Blocks.TRIPWIRE || bpe7.is(BlockTags.WOOL) || super.mineBlock(bek, bjt, byg, fk, akw);
    }
    
    @Override
    public boolean canDestroySpecial(final BlockState byg) {
        final Block bpe3 = byg.getBlock();
        return bpe3 == Blocks.COBWEB || bpe3 == Blocks.REDSTONE_WIRE || bpe3 == Blocks.TRIPWIRE;
    }
    
    @Override
    public float getDestroySpeed(final ItemStack bek, final BlockState byg) {
        final Block bpe4 = byg.getBlock();
        if (bpe4 == Blocks.COBWEB || byg.is(BlockTags.LEAVES)) {
            return 15.0f;
        }
        if (bpe4.is(BlockTags.WOOL)) {
            return 5.0f;
        }
        return super.getDestroySpeed(bek, byg);
    }
}
