package net.minecraft.world.item;

import net.minecraft.stats.Stat;
import net.minecraft.stats.Stats;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.projectile.ThrownPotion;
import net.minecraft.world.InteractionResultHolder;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.Level;

public class ThrowablePotionItem extends PotionItem {
    public ThrowablePotionItem(final Properties a) {
        super(a);
    }
    
    @Override
    public InteractionResultHolder<ItemStack> use(final Level bjt, final Player ayg, final InteractionHand ajh) {
        final ItemStack bek5 = ayg.getItemInHand(ajh);
        if (!bjt.isClientSide) {
            final ThrownPotion azg6 = new ThrownPotion(bjt, ayg);
            azg6.setItem(bek5);
            azg6.shootFromRotation(ayg, ayg.xRot, ayg.yRot, -20.0f, 0.5f, 1.0f);
            bjt.addFreshEntity(azg6);
        }
        ayg.awardStat(Stats.ITEM_USED.get(this));
        if (!ayg.abilities.instabuild) {
            bek5.shrink(1);
        }
        return InteractionResultHolder.<ItemStack>success(bek5);
    }
}
