package net.minecraft.world.item;

public class TieredItem extends Item {
    private final Tier tier;
    
    public TieredItem(final Tier bfp, final Properties a) {
        super(a.defaultDurability(bfp.getUses()));
        this.tier = bfp;
    }
    
    public Tier getTier() {
        return this.tier;
    }
    
    @Override
    public int getEnchantmentValue() {
        return this.tier.getEnchantmentValue();
    }
    
    @Override
    public boolean isValidRepairItem(final ItemStack bek1, final ItemStack bek2) {
        return this.tier.getRepairIngredient().test(bek2) || super.isValidRepairItem(bek1, bek2);
    }
}
