package net.minecraft.world.item.crafting;

import net.minecraft.world.Container;
import net.minecraft.world.item.Item;
import java.util.List;
import net.minecraft.world.item.DyeItem;
import net.minecraft.world.item.DyeableLeatherItem;
import com.google.common.collect.Lists;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.inventory.CraftingContainer;
import net.minecraft.resources.ResourceLocation;

public class ArmorDyeRecipe extends CustomRecipe {
    public ArmorDyeRecipe(final ResourceLocation sm) {
        super(sm);
    }
    
    @Override
    public boolean matches(final CraftingContainer baw, final Level bjt) {
        ItemStack bek4 = ItemStack.EMPTY;
        final List<ItemStack> list5 = Lists.newArrayList();
        for (int integer6 = 0; integer6 < baw.getContainerSize(); ++integer6) {
            final ItemStack bek5 = baw.getItem(integer6);
            if (!bek5.isEmpty()) {
                if (bek5.getItem() instanceof DyeableLeatherItem) {
                    if (!bek4.isEmpty()) {
                        return false;
                    }
                    bek4 = bek5;
                }
                else {
                    if (!(bek5.getItem() instanceof DyeItem)) {
                        return false;
                    }
                    list5.add(bek5);
                }
            }
        }
        return !bek4.isEmpty() && !list5.isEmpty();
    }
    
    @Override
    public ItemStack assemble(final CraftingContainer baw) {
        final List<DyeItem> list3 = Lists.newArrayList();
        ItemStack bek4 = ItemStack.EMPTY;
        for (int integer5 = 0; integer5 < baw.getContainerSize(); ++integer5) {
            final ItemStack bek5 = baw.getItem(integer5);
            if (!bek5.isEmpty()) {
                final Item bef7 = bek5.getItem();
                if (bef7 instanceof DyeableLeatherItem) {
                    if (!bek4.isEmpty()) {
                        return ItemStack.EMPTY;
                    }
                    bek4 = bek5.copy();
                }
                else {
                    if (!(bef7 instanceof DyeItem)) {
                        return ItemStack.EMPTY;
                    }
                    list3.add((DyeItem)bef7);
                }
            }
        }
        if (bek4.isEmpty() || list3.isEmpty()) {
            return ItemStack.EMPTY;
        }
        return DyeableLeatherItem.dyeArmor(bek4, list3);
    }
    
    @Override
    public boolean canCraftInDimensions(final int integer1, final int integer2) {
        return integer1 * integer2 >= 2;
    }
    
    @Override
    public RecipeSerializer<?> getSerializer() {
        return RecipeSerializer.ARMOR_DYE;
    }
}
