package net.minecraft.world.item.crafting;

import net.minecraft.world.Container;
import net.minecraft.world.level.ItemLike;
import net.minecraft.core.NonNullList;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.DyeColor;
import net.minecraft.world.level.block.entity.BannerBlockEntity;
import net.minecraft.world.item.BannerItem;
import net.minecraft.world.level.Level;
import net.minecraft.world.inventory.CraftingContainer;
import net.minecraft.resources.ResourceLocation;

public class BannerDuplicateRecipe extends CustomRecipe {
    public BannerDuplicateRecipe(final ResourceLocation sm) {
        super(sm);
    }
    
    @Override
    public boolean matches(final CraftingContainer baw, final Level bjt) {
        DyeColor bdg4 = null;
        ItemStack bek5 = null;
        ItemStack bek6 = null;
        for (int integer7 = 0; integer7 < baw.getContainerSize(); ++integer7) {
            final ItemStack bek7 = baw.getItem(integer7);
            final Item bef9 = bek7.getItem();
            if (bef9 instanceof BannerItem) {
                final BannerItem bcj10 = (BannerItem)bef9;
                if (bdg4 == null) {
                    bdg4 = bcj10.getColor();
                }
                else if (bdg4 != bcj10.getColor()) {
                    return false;
                }
                final int integer8 = BannerBlockEntity.getPatternCount(bek7);
                if (integer8 > 6) {
                    return false;
                }
                if (integer8 > 0) {
                    if (bek5 != null) {
                        return false;
                    }
                    bek5 = bek7;
                }
                else {
                    if (bek6 != null) {
                        return false;
                    }
                    bek6 = bek7;
                }
            }
        }
        return bek5 != null && bek6 != null;
    }
    
    @Override
    public ItemStack assemble(final CraftingContainer baw) {
        for (int integer3 = 0; integer3 < baw.getContainerSize(); ++integer3) {
            final ItemStack bek4 = baw.getItem(integer3);
            if (!bek4.isEmpty()) {
                final int integer4 = BannerBlockEntity.getPatternCount(bek4);
                if (integer4 > 0 && integer4 <= 6) {
                    final ItemStack bek5 = bek4.copy();
                    bek5.setCount(1);
                    return bek5;
                }
            }
        }
        return ItemStack.EMPTY;
    }
    
    @Override
    public NonNullList<ItemStack> getRemainingItems(final CraftingContainer baw) {
        final NonNullList<ItemStack> fy3 = NonNullList.<ItemStack>withSize(baw.getContainerSize(), ItemStack.EMPTY);
        for (int integer4 = 0; integer4 < fy3.size(); ++integer4) {
            final ItemStack bek5 = baw.getItem(integer4);
            if (!bek5.isEmpty()) {
                if (bek5.getItem().hasCraftingRemainingItem()) {
                    fy3.set(integer4, new ItemStack(bek5.getItem().getCraftingRemainingItem()));
                }
                else if (bek5.hasTag() && BannerBlockEntity.getPatternCount(bek5) > 0) {
                    final ItemStack bek6 = bek5.copy();
                    bek6.setCount(1);
                    fy3.set(integer4, bek6);
                }
            }
        }
        return fy3;
    }
    
    @Override
    public RecipeSerializer<?> getSerializer() {
        return RecipeSerializer.BANNER_DUPLICATE;
    }
    
    @Override
    public boolean canCraftInDimensions(final int integer1, final int integer2) {
        return integer1 * integer2 >= 2;
    }
}
