package net.minecraft.world.item.crafting;

import net.minecraft.world.Container;
import net.minecraft.core.NonNullList;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.WrittenBookItem;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.inventory.CraftingContainer;
import net.minecraft.resources.ResourceLocation;

public class BookCloningRecipe extends CustomRecipe {
    public BookCloningRecipe(final ResourceLocation sm) {
        super(sm);
    }
    
    @Override
    public boolean matches(final CraftingContainer baw, final Level bjt) {
        int integer4 = 0;
        ItemStack bek5 = ItemStack.EMPTY;
        for (int integer5 = 0; integer5 < baw.getContainerSize(); ++integer5) {
            final ItemStack bek6 = baw.getItem(integer5);
            if (!bek6.isEmpty()) {
                if (bek6.getItem() == Items.WRITTEN_BOOK) {
                    if (!bek5.isEmpty()) {
                        return false;
                    }
                    bek5 = bek6;
                }
                else {
                    if (bek6.getItem() != Items.WRITABLE_BOOK) {
                        return false;
                    }
                    ++integer4;
                }
            }
        }
        return !bek5.isEmpty() && bek5.hasTag() && integer4 > 0;
    }
    
    @Override
    public ItemStack assemble(final CraftingContainer baw) {
        int integer3 = 0;
        ItemStack bek4 = ItemStack.EMPTY;
        for (int integer4 = 0; integer4 < baw.getContainerSize(); ++integer4) {
            final ItemStack bek5 = baw.getItem(integer4);
            if (!bek5.isEmpty()) {
                if (bek5.getItem() == Items.WRITTEN_BOOK) {
                    if (!bek4.isEmpty()) {
                        return ItemStack.EMPTY;
                    }
                    bek4 = bek5;
                }
                else {
                    if (bek5.getItem() != Items.WRITABLE_BOOK) {
                        return ItemStack.EMPTY;
                    }
                    ++integer3;
                }
            }
        }
        if (bek4.isEmpty() || !bek4.hasTag() || integer3 < 1 || WrittenBookItem.getGeneration(bek4) >= 2) {
            return ItemStack.EMPTY;
        }
        final ItemStack bek6 = new ItemStack(Items.WRITTEN_BOOK, integer3);
        final CompoundTag jt6 = bek4.getTag().copy();
        jt6.putInt("generation", WrittenBookItem.getGeneration(bek4) + 1);
        bek6.setTag(jt6);
        return bek6;
    }
    
    @Override
    public NonNullList<ItemStack> getRemainingItems(final CraftingContainer baw) {
        final NonNullList<ItemStack> fy3 = NonNullList.<ItemStack>withSize(baw.getContainerSize(), ItemStack.EMPTY);
        for (int integer4 = 0; integer4 < fy3.size(); ++integer4) {
            final ItemStack bek5 = baw.getItem(integer4);
            if (bek5.getItem().hasCraftingRemainingItem()) {
                fy3.set(integer4, new ItemStack(bek5.getItem().getCraftingRemainingItem()));
            }
            else if (bek5.getItem() instanceof WrittenBookItem) {
                final ItemStack bek6 = bek5.copy();
                bek6.setCount(1);
                fy3.set(integer4, bek6);
                break;
            }
        }
        return fy3;
    }
    
    @Override
    public RecipeSerializer<?> getSerializer() {
        return RecipeSerializer.BOOK_CLONING;
    }
    
    @Override
    public boolean canCraftInDimensions(final int integer1, final int integer2) {
        return integer1 >= 3 && integer2 >= 3;
    }
}
