package net.minecraft.world.item.crafting;

import net.minecraft.world.Container;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.inventory.CraftingContainer;
import net.minecraft.resources.ResourceLocation;

public class MapCloningRecipe extends CustomRecipe {
    public MapCloningRecipe(final ResourceLocation sm) {
        super(sm);
    }
    
    @Override
    public boolean matches(final CraftingContainer baw, final Level bjt) {
        int integer4 = 0;
        ItemStack bek5 = ItemStack.EMPTY;
        for (int integer5 = 0; integer5 < baw.getContainerSize(); ++integer5) {
            final ItemStack bek6 = baw.getItem(integer5);
            if (!bek6.isEmpty()) {
                if (bek6.getItem() == Items.FILLED_MAP) {
                    if (!bek5.isEmpty()) {
                        return false;
                    }
                    bek5 = bek6;
                }
                else {
                    if (bek6.getItem() != Items.MAP) {
                        return false;
                    }
                    ++integer4;
                }
            }
        }
        return !bek5.isEmpty() && integer4 > 0;
    }
    
    @Override
    public ItemStack assemble(final CraftingContainer baw) {
        int integer3 = 0;
        ItemStack bek4 = ItemStack.EMPTY;
        for (int integer4 = 0; integer4 < baw.getContainerSize(); ++integer4) {
            final ItemStack bek5 = baw.getItem(integer4);
            if (!bek5.isEmpty()) {
                if (bek5.getItem() == Items.FILLED_MAP) {
                    if (!bek4.isEmpty()) {
                        return ItemStack.EMPTY;
                    }
                    bek4 = bek5;
                }
                else {
                    if (bek5.getItem() != Items.MAP) {
                        return ItemStack.EMPTY;
                    }
                    ++integer3;
                }
            }
        }
        if (bek4.isEmpty() || integer3 < 1) {
            return ItemStack.EMPTY;
        }
        final ItemStack bek6 = bek4.copy();
        bek6.setCount(integer3 + 1);
        return bek6;
    }
    
    @Override
    public boolean canCraftInDimensions(final int integer1, final int integer2) {
        return integer1 >= 3 && integer2 >= 3;
    }
    
    @Override
    public RecipeSerializer<?> getSerializer() {
        return RecipeSerializer.MAP_CLONING;
    }
}
