package net.minecraft.world.item.crafting;

import net.minecraft.world.Container;
import net.minecraft.world.item.Item;
import net.minecraft.world.level.ItemLike;
import java.util.List;
import net.minecraft.world.item.ItemStack;
import com.google.common.collect.Lists;
import net.minecraft.world.level.Level;
import net.minecraft.world.inventory.CraftingContainer;
import net.minecraft.resources.ResourceLocation;

public class RepairItemRecipe extends CustomRecipe {
    public RepairItemRecipe(final ResourceLocation sm) {
        super(sm);
    }
    
    @Override
    public boolean matches(final CraftingContainer baw, final Level bjt) {
        final List<ItemStack> list4 = Lists.newArrayList();
        for (int integer5 = 0; integer5 < baw.getContainerSize(); ++integer5) {
            final ItemStack bek6 = baw.getItem(integer5);
            if (!bek6.isEmpty()) {
                list4.add(bek6);
                if (list4.size() > 1) {
                    final ItemStack bek7 = list4.get(0);
                    if (bek6.getItem() != bek7.getItem() || bek7.getCount() != 1 || bek6.getCount() != 1 || !bek7.getItem().canBeDepleted()) {
                        return false;
                    }
                }
            }
        }
        return list4.size() == 2;
    }
    
    @Override
    public ItemStack assemble(final CraftingContainer baw) {
        final List<ItemStack> list3 = Lists.newArrayList();
        for (int integer4 = 0; integer4 < baw.getContainerSize(); ++integer4) {
            final ItemStack bek5 = baw.getItem(integer4);
            if (!bek5.isEmpty()) {
                list3.add(bek5);
                if (list3.size() > 1) {
                    final ItemStack bek6 = list3.get(0);
                    if (bek5.getItem() != bek6.getItem() || bek6.getCount() != 1 || bek5.getCount() != 1 || !bek6.getItem().canBeDepleted()) {
                        return ItemStack.EMPTY;
                    }
                }
            }
        }
        if (list3.size() == 2) {
            final ItemStack bek7 = list3.get(0);
            final ItemStack bek5 = list3.get(1);
            if (bek7.getItem() == bek5.getItem() && bek7.getCount() == 1 && bek5.getCount() == 1 && bek7.getItem().canBeDepleted()) {
                final Item bef6 = bek7.getItem();
                final int integer5 = bef6.getMaxDamage() - bek7.getDamageValue();
                final int integer6 = bef6.getMaxDamage() - bek5.getDamageValue();
                final int integer7 = integer5 + integer6 + bef6.getMaxDamage() * 5 / 100;
                int integer8 = bef6.getMaxDamage() - integer7;
                if (integer8 < 0) {
                    integer8 = 0;
                }
                final ItemStack bek8 = new ItemStack(bek7.getItem());
                bek8.setDamageValue(integer8);
                return bek8;
            }
        }
        return ItemStack.EMPTY;
    }
    
    @Override
    public boolean canCraftInDimensions(final int integer1, final int integer2) {
        return integer1 * integer2 >= 2;
    }
    
    @Override
    public RecipeSerializer<?> getSerializer() {
        return RecipeSerializer.REPAIR_ITEM;
    }
}
