package net.minecraft.world.item.crafting;

import net.minecraft.world.Container;
import net.minecraft.nbt.Tag;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.BannerItem;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.inventory.CraftingContainer;
import net.minecraft.resources.ResourceLocation;

public class ShieldDecorationRecipe extends CustomRecipe {
    public ShieldDecorationRecipe(final ResourceLocation sm) {
        super(sm);
    }
    
    @Override
    public boolean matches(final CraftingContainer baw, final Level bjt) {
        ItemStack bek4 = ItemStack.EMPTY;
        ItemStack bek5 = ItemStack.EMPTY;
        for (int integer6 = 0; integer6 < baw.getContainerSize(); ++integer6) {
            final ItemStack bek6 = baw.getItem(integer6);
            if (!bek6.isEmpty()) {
                if (bek6.getItem() instanceof BannerItem) {
                    if (!bek5.isEmpty()) {
                        return false;
                    }
                    bek5 = bek6;
                }
                else {
                    if (bek6.getItem() != Items.SHIELD) {
                        return false;
                    }
                    if (!bek4.isEmpty()) {
                        return false;
                    }
                    if (bek6.getTagElement("BlockEntityTag") != null) {
                        return false;
                    }
                    bek4 = bek6;
                }
            }
        }
        return !bek4.isEmpty() && !bek5.isEmpty();
    }
    
    @Override
    public ItemStack assemble(final CraftingContainer baw) {
        ItemStack bek3 = ItemStack.EMPTY;
        ItemStack bek4 = ItemStack.EMPTY;
        for (int integer5 = 0; integer5 < baw.getContainerSize(); ++integer5) {
            final ItemStack bek5 = baw.getItem(integer5);
            if (!bek5.isEmpty()) {
                if (bek5.getItem() instanceof BannerItem) {
                    bek3 = bek5;
                }
                else if (bek5.getItem() == Items.SHIELD) {
                    bek4 = bek5.copy();
                }
            }
        }
        if (bek4.isEmpty()) {
            return bek4;
        }
        final CompoundTag jt5 = bek3.getTagElement("BlockEntityTag");
        final CompoundTag jt6 = (jt5 == null) ? new CompoundTag() : jt5.copy();
        jt6.putInt("Base", ((BannerItem)bek3.getItem()).getColor().getId());
        bek4.addTagElement("BlockEntityTag", jt6);
        return bek4;
    }
    
    @Override
    public boolean canCraftInDimensions(final int integer1, final int integer2) {
        return integer1 * integer2 >= 2;
    }
    
    @Override
    public RecipeSerializer<?> getSerializer() {
        return RecipeSerializer.SHIELD_DECORATION;
    }
}
