package net.minecraft.world.item.crafting;

import net.minecraft.world.Container;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.DyeItem;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.ShulkerBoxBlock;
import net.minecraft.world.level.Level;
import net.minecraft.world.inventory.CraftingContainer;
import net.minecraft.resources.ResourceLocation;

public class ShulkerBoxColoring extends CustomRecipe {
    public ShulkerBoxColoring(final ResourceLocation sm) {
        super(sm);
    }
    
    @Override
    public boolean matches(final CraftingContainer baw, final Level bjt) {
        int integer4 = 0;
        int integer5 = 0;
        for (int integer6 = 0; integer6 < baw.getContainerSize(); ++integer6) {
            final ItemStack bek7 = baw.getItem(integer6);
            if (!bek7.isEmpty()) {
                if (Block.byItem(bek7.getItem()) instanceof ShulkerBoxBlock) {
                    ++integer4;
                }
                else {
                    if (!(bek7.getItem() instanceof DyeItem)) {
                        return false;
                    }
                    ++integer5;
                }
                if (integer5 > 1 || integer4 > 1) {
                    return false;
                }
            }
        }
        return integer4 == 1 && integer5 == 1;
    }
    
    @Override
    public ItemStack assemble(final CraftingContainer baw) {
        ItemStack bek3 = ItemStack.EMPTY;
        DyeItem bdh4 = (DyeItem)Items.WHITE_DYE;
        for (int integer5 = 0; integer5 < baw.getContainerSize(); ++integer5) {
            final ItemStack bek4 = baw.getItem(integer5);
            if (!bek4.isEmpty()) {
                final Item bef7 = bek4.getItem();
                if (Block.byItem(bef7) instanceof ShulkerBoxBlock) {
                    bek3 = bek4;
                }
                else if (bef7 instanceof DyeItem) {
                    bdh4 = (DyeItem)bef7;
                }
            }
        }
        final ItemStack bek5 = ShulkerBoxBlock.getColoredItemStack(bdh4.getDyeColor());
        if (bek3.hasTag()) {
            bek5.setTag(bek3.getTag().copy());
        }
        return bek5;
    }
    
    @Override
    public boolean canCraftInDimensions(final int integer1, final int integer2) {
        return integer1 * integer2 >= 2;
    }
    
    @Override
    public RecipeSerializer<?> getSerializer() {
        return RecipeSerializer.SHULKER_BOX_COLORING;
    }
}
