package net.minecraft.world.item.crafting;

import net.minecraft.world.Container;
import net.minecraft.world.effect.MobEffectInstance;
import java.util.Collection;
import net.minecraft.world.item.alchemy.PotionUtils;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.level.Level;
import net.minecraft.world.inventory.CraftingContainer;
import net.minecraft.resources.ResourceLocation;

public class TippedArrowRecipe extends CustomRecipe {
    public TippedArrowRecipe(final ResourceLocation sm) {
        super(sm);
    }
    
    @Override
    public boolean matches(final CraftingContainer baw, final Level bjt) {
        if (baw.getWidth() != 3 || baw.getHeight() != 3) {
            return false;
        }
        for (int integer4 = 0; integer4 < baw.getWidth(); ++integer4) {
            for (int integer5 = 0; integer5 < baw.getHeight(); ++integer5) {
                final ItemStack bek6 = baw.getItem(integer4 + integer5 * baw.getWidth());
                if (bek6.isEmpty()) {
                    return false;
                }
                final Item bef7 = bek6.getItem();
                if (integer4 == 1 && integer5 == 1) {
                    if (bef7 != Items.LINGERING_POTION) {
                        return false;
                    }
                }
                else if (bef7 != Items.ARROW) {
                    return false;
                }
            }
        }
        return true;
    }
    
    @Override
    public ItemStack assemble(final CraftingContainer baw) {
        final ItemStack bek3 = baw.getItem(1 + baw.getWidth());
        if (bek3.getItem() != Items.LINGERING_POTION) {
            return ItemStack.EMPTY;
        }
        final ItemStack bek4 = new ItemStack(Items.TIPPED_ARROW, 8);
        PotionUtils.setPotion(bek4, PotionUtils.getPotion(bek3));
        PotionUtils.setCustomEffects(bek4, PotionUtils.getCustomEffects(bek3));
        return bek4;
    }
    
    @Override
    public boolean canCraftInDimensions(final int integer1, final int integer2) {
        return integer1 >= 2 && integer2 >= 2;
    }
    
    @Override
    public RecipeSerializer<?> getSerializer() {
        return RecipeSerializer.TIPPED_ARROW;
    }
}
