package net.minecraft.world.item.trading;

import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.entity.player.Inventory;
import java.util.OptionalInt;
import net.minecraft.world.MenuProvider;
import net.minecraft.world.SimpleMenuProvider;
import net.minecraft.world.inventory.MerchantMenu;
import net.minecraft.network.chat.Component;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.world.level.Level;
import net.minecraft.world.item.ItemStack;
import javax.annotation.Nullable;
import net.minecraft.world.entity.player.Player;

public interface Merchant {
    void setTradingPlayer(@Nullable final Player ayg);
    
    @Nullable
    Player getTradingPlayer();
    
    MerchantOffers getOffers();
    
    void overrideOffers(@Nullable final MerchantOffers bix);
    
    void notifyTrade(final MerchantOffer biw);
    
    void notifyTradeUpdated(final ItemStack bek);
    
    Level getLevel();
    
    int getVillagerXp();
    
    void overrideXp(final int integer);
    
    boolean showProgressBar();
    
    SoundEvent getNotifyTradeSound();
    
    default boolean canRestock() {
        return false;
    }
    
    default void openTradingScreen(final Player ayg, final Component lf, final int integer) {
        final OptionalInt optionalInt5 = ayg.openMenu(new SimpleMenuProvider((integer, ayf, ayg) -> new MerchantMenu(integer, ayf, this), lf));
        if (optionalInt5.isPresent()) {
            final MerchantOffers bix6 = this.getOffers();
            if (!bix6.isEmpty()) {
                ayg.sendMerchantOffers(optionalInt5.getAsInt(), bix6, integer, this.getVillagerXp(), this.showProgressBar(), this.canRestock());
            }
        }
    }
}
