package net.minecraft.world.level.biome;

import net.minecraft.world.level.storage.LevelData;
import net.minecraft.world.level.levelgen.OverworldGeneratorSettings;
import net.minecraft.world.level.LevelType;

public class OverworldBiomeSourceSettings implements BiomeSourceSettings {
    private final long seed;
    private final LevelType generatorType;
    private OverworldGeneratorSettings generatorSettings;
    
    public OverworldBiomeSourceSettings(final LevelData crj) {
        this.generatorSettings = new OverworldGeneratorSettings();
        this.seed = crj.getSeed();
        this.generatorType = crj.getGeneratorType();
    }
    
    public OverworldBiomeSourceSettings setGeneratorSettings(final OverworldGeneratorSettings cbw) {
        this.generatorSettings = cbw;
        return this;
    }
    
    public long getSeed() {
        return this.seed;
    }
    
    public LevelType getGeneratorType() {
        return this.generatorType;
    }
    
    public OverworldGeneratorSettings getGeneratorSettings() {
        return this.generatorSettings;
    }
}
