package net.minecraft.world.level.block;

import javax.annotation.Nullable;
import net.minecraft.world.MenuProvider;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.state.BlockState;

public abstract class BaseEntityBlock extends Block implements EntityBlock {
    protected BaseEntityBlock(final Properties c) {
        super(c);
    }
    
    @Override
    public RenderShape getRenderShape(final BlockState byg) {
        return RenderShape.INVISIBLE;
    }
    
    @Override
    public boolean triggerEvent(final BlockState byg, final Level bjt, final BlockPos fk, final int integer4, final int integer5) {
        super.triggerEvent(byg, bjt, fk, integer4, integer5);
        final BlockEntity bwi7 = bjt.getBlockEntity(fk);
        return bwi7 != null && bwi7.triggerEvent(integer4, integer5);
    }
    
    @Nullable
    @Override
    public MenuProvider getMenuProvider(final BlockState byg, final Level bjt, final BlockPos fk) {
        final BlockEntity bwi5 = bjt.getBlockEntity(fk);
        return (bwi5 instanceof MenuProvider) ? bwi5 : null;
    }
}
