package net.minecraft.world.level.block;

import net.minecraft.world.level.block.state.AbstractStateHolder;
import net.minecraft.world.level.pathfinder.PathComputationType;
import net.minecraft.world.level.block.state.StateDefinition;
import java.util.Iterator;
import java.util.Random;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.level.block.state.properties.BooleanProperty;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.core.Direction;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.item.BlockPlaceContext;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.level.block.state.BlockState;

public class ChorusPlantBlock extends PipeBlock {
    protected ChorusPlantBlock(final Properties c) {
        super(0.3125f, c);
        this.registerDefaultState((((((((AbstractStateHolder<O, BlockState>)this.stateDefinition.any()).setValue((Property<Comparable>)ChorusPlantBlock.NORTH, false)).setValue((Property<Comparable>)ChorusPlantBlock.EAST, false)).setValue((Property<Comparable>)ChorusPlantBlock.SOUTH, false)).setValue((Property<Comparable>)ChorusPlantBlock.WEST, false)).setValue((Property<Comparable>)ChorusPlantBlock.UP, false)).<Comparable, Boolean>setValue((Property<Comparable>)ChorusPlantBlock.DOWN, false));
    }
    
    @Override
    public BlockState getStateForPlacement(final BlockPlaceContext bcn) {
        return this.getStateForPlacement(bcn.getLevel(), bcn.getClickedPos());
    }
    
    public BlockState getStateForPlacement(final BlockGetter bjd, final BlockPos fk) {
        final Block bpe4 = bjd.getBlockState(fk.below()).getBlock();
        final Block bpe5 = bjd.getBlockState(fk.above()).getBlock();
        final Block bpe6 = bjd.getBlockState(fk.north()).getBlock();
        final Block bpe7 = bjd.getBlockState(fk.east()).getBlock();
        final Block bpe8 = bjd.getBlockState(fk.south()).getBlock();
        final Block bpe9 = bjd.getBlockState(fk.west()).getBlock();
        return (((((((AbstractStateHolder<O, BlockState>)this.defaultBlockState()).setValue((Property<Comparable>)ChorusPlantBlock.DOWN, bpe4 == this || bpe4 == Blocks.CHORUS_FLOWER || bpe4 == Blocks.END_STONE)).setValue((Property<Comparable>)ChorusPlantBlock.UP, bpe5 == this || bpe5 == Blocks.CHORUS_FLOWER)).setValue((Property<Comparable>)ChorusPlantBlock.NORTH, bpe6 == this || bpe6 == Blocks.CHORUS_FLOWER)).setValue((Property<Comparable>)ChorusPlantBlock.EAST, bpe7 == this || bpe7 == Blocks.CHORUS_FLOWER)).setValue((Property<Comparable>)ChorusPlantBlock.SOUTH, bpe8 == this || bpe8 == Blocks.CHORUS_FLOWER)).<Comparable, Boolean>setValue((Property<Comparable>)ChorusPlantBlock.WEST, bpe9 == this || bpe9 == Blocks.CHORUS_FLOWER);
    }
    
    @Override
    public BlockState updateShape(final BlockState byg1, final Direction fp, final BlockState byg3, final LevelAccessor bju, final BlockPos fk5, final BlockPos fk6) {
        if (!byg1.canSurvive(bju, fk5)) {
            bju.getBlockTicks().scheduleTick(fk5, this, 1);
            return super.updateShape(byg1, fp, byg3, bju, fk5, fk6);
        }
        final Block bpe8 = byg3.getBlock();
        final boolean boolean9 = bpe8 == this || bpe8 == Blocks.CHORUS_FLOWER || (fp == Direction.DOWN && bpe8 == Blocks.END_STONE);
        return ((AbstractStateHolder<O, BlockState>)byg1).<Comparable, Boolean>setValue((Property<Comparable>)ChorusPlantBlock.PROPERTY_BY_DIRECTION.get(fp), boolean9);
    }
    
    @Override
    public void tick(final BlockState byg, final ServerLevel xd, final BlockPos fk, final Random random) {
        if (!byg.canSurvive(xd, fk)) {
            xd.destroyBlock(fk, true);
        }
    }
    
    @Override
    public boolean canSurvive(final BlockState byg, final LevelReader bjw, final BlockPos fk) {
        final BlockState byg2 = bjw.getBlockState(fk.below());
        final boolean boolean6 = !bjw.getBlockState(fk.above()).isAir() && !byg2.isAir();
        for (final Direction fp8 : Direction.Plane.HORIZONTAL) {
            final BlockPos fk2 = fk.relative(fp8);
            final Block bpe10 = bjw.getBlockState(fk2).getBlock();
            if (bpe10 == this) {
                if (boolean6) {
                    return false;
                }
                final Block bpe11 = bjw.getBlockState(fk2.below()).getBlock();
                if (bpe11 == this || bpe11 == Blocks.END_STONE) {
                    return true;
                }
                continue;
            }
        }
        final Block bpe12 = byg2.getBlock();
        return bpe12 == this || bpe12 == Blocks.END_STONE;
    }
    
    @Override
    protected void createBlockStateDefinition(final StateDefinition.Builder<Block, BlockState> a) {
        a.add(ChorusPlantBlock.NORTH, ChorusPlantBlock.EAST, ChorusPlantBlock.SOUTH, ChorusPlantBlock.WEST, ChorusPlantBlock.UP, ChorusPlantBlock.DOWN);
    }
    
    @Override
    public boolean isPathfindable(final BlockState byg, final BlockGetter bjd, final BlockPos fk, final PathComputationType cqo) {
        return false;
    }
}
