package net.minecraft.world.level.block;

import net.minecraft.world.phys.shapes.CollisionContext;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.phys.shapes.VoxelShape;

public class DeadBushBlock extends BushBlock {
    protected static final VoxelShape SHAPE;
    
    protected DeadBushBlock(final Properties c) {
        super(c);
    }
    
    @Override
    public VoxelShape getShape(final BlockState byg, final BlockGetter bjd, final BlockPos fk, final CollisionContext cvn) {
        return DeadBushBlock.SHAPE;
    }
    
    @Override
    protected boolean mayPlaceOn(final BlockState byg, final BlockGetter bjd, final BlockPos fk) {
        final Block bpe5 = byg.getBlock();
        return bpe5 == Blocks.SAND || bpe5 == Blocks.RED_SAND || bpe5 == Blocks.TERRACOTTA || bpe5 == Blocks.WHITE_TERRACOTTA || bpe5 == Blocks.ORANGE_TERRACOTTA || bpe5 == Blocks.MAGENTA_TERRACOTTA || bpe5 == Blocks.LIGHT_BLUE_TERRACOTTA || bpe5 == Blocks.YELLOW_TERRACOTTA || bpe5 == Blocks.LIME_TERRACOTTA || bpe5 == Blocks.PINK_TERRACOTTA || bpe5 == Blocks.GRAY_TERRACOTTA || bpe5 == Blocks.LIGHT_GRAY_TERRACOTTA || bpe5 == Blocks.CYAN_TERRACOTTA || bpe5 == Blocks.PURPLE_TERRACOTTA || bpe5 == Blocks.BLUE_TERRACOTTA || bpe5 == Blocks.BROWN_TERRACOTTA || bpe5 == Blocks.GREEN_TERRACOTTA || bpe5 == Blocks.RED_TERRACOTTA || bpe5 == Blocks.BLACK_TERRACOTTA || bpe5 == Blocks.DIRT || bpe5 == Blocks.COARSE_DIRT || bpe5 == Blocks.PODZOL;
    }
    
    static {
        SHAPE = Block.box(2.0, 0.0, 2.0, 14.0, 13.0, 14.0);
    }
}
