package net.minecraft.world.level.block;

import net.minecraft.world.level.block.state.AbstractStateHolder;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.state.properties.BooleanProperty;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.material.FluidState;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.material.Fluids;
import net.minecraft.core.Direction;
import net.minecraft.world.item.BlockPlaceContext;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.level.block.state.BlockState;

public class IronBarsBlock extends CrossCollisionBlock {
    protected IronBarsBlock(final Properties c) {
        super(1.0f, 1.0f, 16.0f, 16.0f, 16.0f, c);
        this.registerDefaultState(((((((AbstractStateHolder<O, BlockState>)this.stateDefinition.any()).setValue((Property<Comparable>)IronBarsBlock.NORTH, false)).setValue((Property<Comparable>)IronBarsBlock.EAST, false)).setValue((Property<Comparable>)IronBarsBlock.SOUTH, false)).setValue((Property<Comparable>)IronBarsBlock.WEST, false)).<Comparable, Boolean>setValue((Property<Comparable>)IronBarsBlock.WATERLOGGED, false));
    }
    
    @Override
    public BlockState getStateForPlacement(final BlockPlaceContext bcn) {
        final BlockGetter bjd3 = bcn.getLevel();
        final BlockPos fk4 = bcn.getClickedPos();
        final FluidState cog5 = bcn.getLevel().getFluidState(bcn.getClickedPos());
        final BlockPos fk5 = fk4.north();
        final BlockPos fk6 = fk4.south();
        final BlockPos fk7 = fk4.west();
        final BlockPos fk8 = fk4.east();
        final BlockState byg10 = bjd3.getBlockState(fk5);
        final BlockState byg11 = bjd3.getBlockState(fk6);
        final BlockState byg12 = bjd3.getBlockState(fk7);
        final BlockState byg13 = bjd3.getBlockState(fk8);
        return ((((((AbstractStateHolder<O, BlockState>)this.defaultBlockState()).setValue((Property<Comparable>)IronBarsBlock.NORTH, this.attachsTo(byg10, byg10.isFaceSturdy(bjd3, fk5, Direction.SOUTH)))).setValue((Property<Comparable>)IronBarsBlock.SOUTH, this.attachsTo(byg11, byg11.isFaceSturdy(bjd3, fk6, Direction.NORTH)))).setValue((Property<Comparable>)IronBarsBlock.WEST, this.attachsTo(byg12, byg12.isFaceSturdy(bjd3, fk7, Direction.EAST)))).setValue((Property<Comparable>)IronBarsBlock.EAST, this.attachsTo(byg13, byg13.isFaceSturdy(bjd3, fk8, Direction.WEST)))).<Comparable, Boolean>setValue((Property<Comparable>)IronBarsBlock.WATERLOGGED, cog5.getType() == Fluids.WATER);
    }
    
    @Override
    public BlockState updateShape(final BlockState byg1, final Direction fp, final BlockState byg3, final LevelAccessor bju, final BlockPos fk5, final BlockPos fk6) {
        if (byg1.<Boolean>getValue((Property<Boolean>)IronBarsBlock.WATERLOGGED)) {
            bju.getLiquidTicks().scheduleTick(fk5, Fluids.WATER, Fluids.WATER.getTickDelay(bju));
        }
        if (fp.getAxis().isHorizontal()) {
            return ((AbstractStateHolder<O, BlockState>)byg1).<Comparable, Boolean>setValue((Property<Comparable>)IronBarsBlock.PROPERTY_BY_DIRECTION.get(fp), this.attachsTo(byg3, byg3.isFaceSturdy(bju, fk6, fp.getOpposite())));
        }
        return super.updateShape(byg1, fp, byg3, bju, fk5, fk6);
    }
    
    @Override
    public boolean skipRendering(final BlockState byg1, final BlockState byg2, final Direction fp) {
        if (byg2.getBlock() == this) {
            if (!fp.getAxis().isHorizontal()) {
                return true;
            }
            if (byg1.<Boolean>getValue((Property<Boolean>)IronBarsBlock.PROPERTY_BY_DIRECTION.get(fp)) && byg2.<Boolean>getValue((Property<Boolean>)IronBarsBlock.PROPERTY_BY_DIRECTION.get(fp.getOpposite()))) {
                return true;
            }
        }
        return super.skipRendering(byg1, byg2, fp);
    }
    
    public final boolean attachsTo(final BlockState byg, final boolean boolean2) {
        final Block bpe4 = byg.getBlock();
        return (!Block.isExceptionForConnection(bpe4) && boolean2) || bpe4 instanceof IronBarsBlock;
    }
    
    @Override
    protected void createBlockStateDefinition(final StateDefinition.Builder<Block, BlockState> a) {
        a.add(IronBarsBlock.NORTH, IronBarsBlock.EAST, IronBarsBlock.WEST, IronBarsBlock.SOUTH, IronBarsBlock.WATERLOGGED);
    }
}
