package net.minecraft.world.level.block;

import net.minecraft.world.level.block.state.AbstractStateHolder;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.block.state.StateDefinition;
import java.util.Random;
import net.minecraft.server.level.ServerLevel;
import javax.annotation.Nullable;
import net.minecraft.world.item.BlockPlaceContext;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.properties.BooleanProperty;

public class RedstoneLampBlock extends Block {
    public static final BooleanProperty LIT;
    
    public RedstoneLampBlock(final Properties c) {
        super(c);
        this.registerDefaultState(((AbstractStateHolder<O, BlockState>)this.defaultBlockState()).<Comparable, Boolean>setValue((Property<Comparable>)RedstoneLampBlock.LIT, false));
    }
    
    @Override
    public int getLightEmission(final BlockState byg) {
        return byg.<Boolean>getValue((Property<Boolean>)RedstoneLampBlock.LIT) ? super.getLightEmission(byg) : 0;
    }
    
    @Override
    public void onPlace(final BlockState byg1, final Level bjt, final BlockPos fk, final BlockState byg4, final boolean boolean5) {
        super.onPlace(byg1, bjt, fk, byg4, boolean5);
    }
    
    @Nullable
    @Override
    public BlockState getStateForPlacement(final BlockPlaceContext bcn) {
        return ((AbstractStateHolder<O, BlockState>)this.defaultBlockState()).<Comparable, Boolean>setValue((Property<Comparable>)RedstoneLampBlock.LIT, bcn.getLevel().hasNeighborSignal(bcn.getClickedPos()));
    }
    
    @Override
    public void neighborChanged(final BlockState byg, final Level bjt, final BlockPos fk3, final Block bpe, final BlockPos fk5, final boolean boolean6) {
        if (bjt.isClientSide) {
            return;
        }
        final boolean boolean7 = byg.<Boolean>getValue((Property<Boolean>)RedstoneLampBlock.LIT);
        if (boolean7 != bjt.hasNeighborSignal(fk3)) {
            if (boolean7) {
                bjt.getBlockTicks().scheduleTick(fk3, this, 4);
            }
            else {
                bjt.setBlock(fk3, ((AbstractStateHolder<O, BlockState>)byg).<Comparable>cycle((Property<Comparable>)RedstoneLampBlock.LIT), 2);
            }
        }
    }
    
    @Override
    public void tick(final BlockState byg, final ServerLevel xd, final BlockPos fk, final Random random) {
        if (byg.<Boolean>getValue((Property<Boolean>)RedstoneLampBlock.LIT) && !xd.hasNeighborSignal(fk)) {
            xd.setBlock(fk, ((AbstractStateHolder<O, BlockState>)byg).<Comparable>cycle((Property<Comparable>)RedstoneLampBlock.LIT), 2);
        }
    }
    
    @Override
    protected void createBlockStateDefinition(final StateDefinition.Builder<Block, BlockState> a) {
        a.add(RedstoneLampBlock.LIT);
    }
    
    @Override
    public boolean isValidSpawn(final BlockState byg, final BlockGetter bjd, final BlockPos fk, final EntityType<?> akr) {
        return true;
    }
    
    static {
        LIT = RedstoneTorchBlock.LIT;
    }
}
