package net.minecraft.world.level.block;

import net.minecraft.world.level.block.state.AbstractStateHolder;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.material.Fluids;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.level.block.state.properties.BlockStateProperties;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.BlockGetter;

public interface SimpleWaterloggedBlock extends BucketPickup, LiquidBlockContainer {
    default boolean canPlaceLiquid(final BlockGetter bjd, final BlockPos fk, final BlockState byg, final Fluid cof) {
        return !byg.<Boolean>getValue((Property<Boolean>)BlockStateProperties.WATERLOGGED) && cof == Fluids.WATER;
    }
    
    default boolean placeLiquid(final LevelAccessor bju, final BlockPos fk, final BlockState byg, final FluidState cog) {
        if (!byg.<Boolean>getValue((Property<Boolean>)BlockStateProperties.WATERLOGGED) && cog.getType() == Fluids.WATER) {
            if (!bju.isClientSide()) {
                bju.setBlock(fk, ((AbstractStateHolder<O, BlockState>)byg).<Comparable, Boolean>setValue((Property<Comparable>)BlockStateProperties.WATERLOGGED, true), 3);
                bju.getLiquidTicks().scheduleTick(fk, cog.getType(), cog.getType().getTickDelay(bju));
            }
            return true;
        }
        return false;
    }
    
    default Fluid takeLiquid(final LevelAccessor bju, final BlockPos fk, final BlockState byg) {
        if (byg.<Boolean>getValue((Property<Boolean>)BlockStateProperties.WATERLOGGED)) {
            bju.setBlock(fk, ((AbstractStateHolder<O, BlockState>)byg).<Comparable, Boolean>setValue((Property<Comparable>)BlockStateProperties.WATERLOGGED, false), 3);
            return Fluids.WATER;
        }
        return Fluids.EMPTY;
    }
}
