package net.minecraft.world.level.block;

import net.minecraft.world.level.block.state.AbstractStateHolder;
import net.minecraft.world.level.block.state.properties.BlockStateProperties;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.item.BlockPlaceContext;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.core.Direction;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.properties.BooleanProperty;

public class SnowyDirtBlock extends Block {
    public static final BooleanProperty SNOWY;
    
    protected SnowyDirtBlock(final Properties c) {
        super(c);
        this.registerDefaultState(((AbstractStateHolder<O, BlockState>)this.stateDefinition.any()).<Comparable, Boolean>setValue((Property<Comparable>)SnowyDirtBlock.SNOWY, false));
    }
    
    @Override
    public BlockState updateShape(final BlockState byg1, final Direction fp, final BlockState byg3, final LevelAccessor bju, final BlockPos fk5, final BlockPos fk6) {
        if (fp == Direction.UP) {
            final Block bpe8 = byg3.getBlock();
            return ((AbstractStateHolder<O, BlockState>)byg1).<Comparable, Boolean>setValue((Property<Comparable>)SnowyDirtBlock.SNOWY, bpe8 == Blocks.SNOW_BLOCK || bpe8 == Blocks.SNOW);
        }
        return super.updateShape(byg1, fp, byg3, bju, fk5, fk6);
    }
    
    @Override
    public BlockState getStateForPlacement(final BlockPlaceContext bcn) {
        final Block bpe3 = bcn.getLevel().getBlockState(bcn.getClickedPos().above()).getBlock();
        return ((AbstractStateHolder<O, BlockState>)this.defaultBlockState()).<Comparable, Boolean>setValue((Property<Comparable>)SnowyDirtBlock.SNOWY, bpe3 == Blocks.SNOW_BLOCK || bpe3 == Blocks.SNOW);
    }
    
    @Override
    protected void createBlockStateDefinition(final StateDefinition.Builder<Block, BlockState> a) {
        a.add(SnowyDirtBlock.SNOWY);
    }
    
    static {
        SNOWY = BlockStateProperties.SNOWY;
    }
}
