package net.minecraft.world.level.block.grower;

import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.levelgen.ChunkGeneratorSettings;
import net.minecraft.world.level.block.Blocks;
import javax.annotation.Nullable;
import net.minecraft.world.level.levelgen.feature.configurations.MegaTreeConfiguration;
import net.minecraft.world.level.levelgen.feature.ConfiguredFeature;
import net.minecraft.world.level.BlockGetter;
import java.util.Random;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;

public abstract class AbstractMegaTreeGrower extends AbstractTreeGrower {
    @Override
    public boolean growTree(final LevelAccessor bju, final ChunkGenerator<?> bzx, final BlockPos fk, final BlockState byg, final Random random) {
        for (int integer7 = 0; integer7 >= -1; --integer7) {
            for (int integer8 = 0; integer8 >= -1; --integer8) {
                if (isTwoByTwoSapling(byg, bju, fk, integer7, integer8)) {
                    return this.placeMega(bju, bzx, fk, byg, random, integer7, integer8);
                }
            }
        }
        return super.growTree(bju, bzx, fk, byg, random);
    }
    
    @Nullable
    protected abstract ConfiguredFeature<MegaTreeConfiguration, ?> getConfiguredMegaFeature(final Random random);
    
    public boolean placeMega(final LevelAccessor bju, final ChunkGenerator<?> bzx, final BlockPos fk, final BlockState byg, final Random random, final int integer6, final int integer7) {
        final ConfiguredFeature<MegaTreeConfiguration, ?> ccz9 = this.getConfiguredMegaFeature(random);
        if (ccz9 == null) {
            return false;
        }
        final BlockState byg2 = Blocks.AIR.defaultBlockState();
        bju.setBlock(fk.offset(integer6, 0, integer7), byg2, 4);
        bju.setBlock(fk.offset(integer6 + 1, 0, integer7), byg2, 4);
        bju.setBlock(fk.offset(integer6, 0, integer7 + 1), byg2, 4);
        bju.setBlock(fk.offset(integer6 + 1, 0, integer7 + 1), byg2, 4);
        if (ccz9.place(bju, bzx, random, fk.offset(integer6, 0, integer7))) {
            return true;
        }
        bju.setBlock(fk.offset(integer6, 0, integer7), byg, 4);
        bju.setBlock(fk.offset(integer6 + 1, 0, integer7), byg, 4);
        bju.setBlock(fk.offset(integer6, 0, integer7 + 1), byg, 4);
        bju.setBlock(fk.offset(integer6 + 1, 0, integer7 + 1), byg, 4);
        return false;
    }
    
    public static boolean isTwoByTwoSapling(final BlockState byg, final BlockGetter bjd, final BlockPos fk, final int integer4, final int integer5) {
        final Block bpe6 = byg.getBlock();
        return bpe6 == bjd.getBlockState(fk.offset(integer4, 0, integer5)).getBlock() && bpe6 == bjd.getBlockState(fk.offset(integer4 + 1, 0, integer5)).getBlock() && bpe6 == bjd.getBlockState(fk.offset(integer4, 0, integer5 + 1)).getBlock() && bpe6 == bjd.getBlockState(fk.offset(integer4 + 1, 0, integer5 + 1)).getBlock();
    }
}
