package net.minecraft.world.level.block.grower;

import net.minecraft.world.level.levelgen.ChunkGeneratorSettings;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;
import javax.annotation.Nullable;
import net.minecraft.world.level.levelgen.feature.configurations.SmallTreeConfiguration;
import net.minecraft.world.level.levelgen.feature.ConfiguredFeature;
import java.util.Random;

public abstract class AbstractTreeGrower {
    @Nullable
    protected abstract ConfiguredFeature<SmallTreeConfiguration, ?> getConfiguredFeature(final Random random);
    
    public boolean growTree(final LevelAccessor bju, final ChunkGenerator<?> bzx, final BlockPos fk, final BlockState byg, final Random random) {
        final ConfiguredFeature<SmallTreeConfiguration, ?> ccz7 = this.getConfiguredFeature(random);
        if (ccz7 == null) {
            return false;
        }
        bju.setBlock(fk, Blocks.AIR.defaultBlockState(), 4);
        ccz7.config.setFromSapling();
        if (ccz7.place(bju, bzx, random, fk)) {
            return true;
        }
        bju.setBlock(fk, byg, 4);
        return false;
    }
}
