package net.minecraft.world.level.block.state.predicate;

import javax.annotation.Nullable;
import net.minecraft.world.level.material.Material;
import net.minecraft.world.level.block.state.BlockState;
import java.util.function.Predicate;

public class BlockMaterialPredicate implements Predicate<BlockState> {
    private static final BlockMaterialPredicate AIR;
    private final Material material;
    
    private BlockMaterialPredicate(final Material cok) {
        this.material = cok;
    }
    
    public static BlockMaterialPredicate forMaterial(final Material cok) {
        return (cok == Material.AIR) ? BlockMaterialPredicate.AIR : new BlockMaterialPredicate(cok);
    }
    
    @Override
    public boolean test(@Nullable final BlockState byg) {
        return byg != null && byg.getMaterial() == this.material;
    }
    
    static {
        AIR = new BlockMaterialPredicate(Material.AIR) {
            @Override
            public boolean test(@Nullable final BlockState byg) {
                return byg != null && byg.isAir();
            }
        };
    }
}
