package net.minecraft.world.level.block.state.predicate;

import javax.annotation.Nullable;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.state.BlockState;
import java.util.function.Predicate;

public class BlockPredicate implements Predicate<BlockState> {
    private final Block block;
    
    public BlockPredicate(final Block bpe) {
        this.block = bpe;
    }
    
    public static BlockPredicate forBlock(final Block bpe) {
        return new BlockPredicate(bpe);
    }
    
    @Override
    public boolean test(@Nullable final BlockState byg) {
        return byg != null && byg.getBlock() == this.block;
    }
}
