package net.minecraft.world.level.levelgen.feature;

import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.LevelReader;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.levelgen.ChunkGeneratorSettings;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;
import com.mojang.datafixers.Dynamic;
import java.util.function.Function;
import net.minecraft.world.level.levelgen.feature.configurations.FeatureConfiguration;

public abstract class AbstractFlowerFeature<U extends FeatureConfiguration> extends Feature<U> {
    public AbstractFlowerFeature(final Function<Dynamic<?>, ? extends U> function) {
        super(function);
    }
    
    @Override
    public boolean place(final LevelAccessor bju, final ChunkGenerator<? extends ChunkGeneratorSettings> bzx, final Random random, final BlockPos fk, final U cgk) {
        final BlockState byg7 = this.getRandomFlower(random, fk, cgk);
        int integer8 = 0;
        for (int integer9 = 0; integer9 < this.getCount(cgk); ++integer9) {
            final BlockPos fk2 = this.getPos(random, fk, cgk);
            if (bju.isEmptyBlock(fk2) && fk2.getY() < 255 && byg7.canSurvive(bju, fk2) && this.isValid(bju, fk2, cgk)) {
                bju.setBlock(fk2, byg7, 2);
                ++integer8;
            }
        }
        return integer8 > 0;
    }
    
    public abstract boolean isValid(final LevelAccessor bju, final BlockPos fk, final U cgk);
    
    public abstract int getCount(final U cgk);
    
    public abstract BlockPos getPos(final Random random, final BlockPos fk, final U cgk);
    
    public abstract BlockState getRandomFlower(final Random random, final BlockPos fk, final U cgk);
}
