package net.minecraft.world.level.levelgen.feature;

import net.minecraft.world.level.levelgen.feature.configurations.FeatureConfiguration;
import net.minecraft.world.level.block.state.BlockState;
import java.util.Random;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.LevelAccessor;
import com.mojang.datafixers.Dynamic;
import java.util.function.Function;
import net.minecraft.world.level.levelgen.feature.configurations.RandomPatchConfiguration;

public class DefaultFlowerFeature extends AbstractFlowerFeature<RandomPatchConfiguration> {
    public DefaultFlowerFeature(final Function<Dynamic<?>, ? extends RandomPatchConfiguration> function) {
        super(function);
    }
    
    @Override
    public boolean isValid(final LevelAccessor bju, final BlockPos fk, final RandomPatchConfiguration cgy) {
        return !cgy.blacklist.contains(bju.getBlockState(fk));
    }
    
    @Override
    public int getCount(final RandomPatchConfiguration cgy) {
        return cgy.tries;
    }
    
    @Override
    public BlockPos getPos(final Random random, final BlockPos fk, final RandomPatchConfiguration cgy) {
        return fk.offset(random.nextInt(cgy.xspread) - random.nextInt(cgy.xspread), random.nextInt(cgy.yspread) - random.nextInt(cgy.yspread), random.nextInt(cgy.zspread) - random.nextInt(cgy.zspread));
    }
    
    @Override
    public BlockState getRandomFlower(final Random random, final BlockPos fk, final RandomPatchConfiguration cgy) {
        return cgy.stateProvider.getState(random, fk);
    }
}
