package net.minecraft.world.level.levelgen.feature;

import net.minecraft.world.level.levelgen.feature.configurations.FeatureConfiguration;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.tags.FluidTags;
import net.minecraft.world.level.LevelReader;
import net.minecraft.core.Vec3i;
import net.minecraft.world.level.levelgen.Heightmap;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.levelgen.ChunkGeneratorSettings;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;
import com.mojang.datafixers.Dynamic;
import java.util.function.Function;
import net.minecraft.world.level.levelgen.feature.configurations.RandomPatchConfiguration;

public class RandomPatchFeature extends Feature<RandomPatchConfiguration> {
    public RandomPatchFeature(final Function<Dynamic<?>, ? extends RandomPatchConfiguration> function) {
        super(function);
    }
    
    @Override
    public boolean place(final LevelAccessor bju, final ChunkGenerator<? extends ChunkGeneratorSettings> bzx, final Random random, final BlockPos fk, final RandomPatchConfiguration cgy) {
        final BlockState byg7 = cgy.stateProvider.getState(random, fk);
        BlockPos fk2;
        if (cgy.project) {
            fk2 = bju.getHeightmapPos(Heightmap.Types.WORLD_SURFACE_WG, fk);
        }
        else {
            fk2 = fk;
        }
        int integer9 = 0;
        final BlockPos.MutableBlockPos a10 = new BlockPos.MutableBlockPos();
        for (int integer10 = 0; integer10 < cgy.tries; ++integer10) {
            a10.set(fk2).move(random.nextInt(cgy.xspread + 1) - random.nextInt(cgy.xspread + 1), random.nextInt(cgy.yspread + 1) - random.nextInt(cgy.yspread + 1), random.nextInt(cgy.zspread + 1) - random.nextInt(cgy.zspread + 1));
            final BlockPos fk3 = a10.below();
            final BlockState byg8 = bju.getBlockState(fk3);
            if ((bju.isEmptyBlock(a10) || (cgy.canReplace && bju.getBlockState(a10).getMaterial().isReplaceable())) && byg7.canSurvive(bju, a10) && (cgy.whitelist.isEmpty() || cgy.whitelist.contains(byg8.getBlock())) && !cgy.blacklist.contains(byg8) && (!cgy.needWater || bju.getFluidState(fk3.west()).is(FluidTags.WATER) || bju.getFluidState(fk3.east()).is(FluidTags.WATER) || bju.getFluidState(fk3.north()).is(FluidTags.WATER) || bju.getFluidState(fk3.south()).is(FluidTags.WATER))) {
                cgy.blockPlacer.place(bju, a10, byg7, random);
                ++integer9;
            }
        }
        return integer9 > 0;
    }
}
