package net.minecraft.world.level.levelgen.feature;

import net.minecraft.world.level.levelgen.feature.configurations.FeatureConfiguration;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.levelgen.ChunkGeneratorSettings;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;
import com.mojang.datafixers.Dynamic;
import java.util.function.Function;
import net.minecraft.world.level.levelgen.feature.configurations.SimpleBlockConfiguration;

public class SimpleBlockFeature extends Feature<SimpleBlockConfiguration> {
    public SimpleBlockFeature(final Function<Dynamic<?>, ? extends SimpleBlockConfiguration> function) {
        super(function);
    }
    
    @Override
    public boolean place(final LevelAccessor bju, final ChunkGenerator<? extends ChunkGeneratorSettings> bzx, final Random random, final BlockPos fk, final SimpleBlockConfiguration chd) {
        if (chd.placeOn.contains(bju.getBlockState(fk.below())) && chd.placeIn.contains(bju.getBlockState(fk)) && chd.placeUnder.contains(bju.getBlockState(fk.above()))) {
            bju.setBlock(fk, chd.toPlace, 2);
            return true;
        }
        return false;
    }
}
