package net.minecraft.world.level.levelgen.feature;

import net.minecraft.world.level.levelgen.feature.configurations.FeatureConfiguration;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.levelgen.ChunkGeneratorSettings;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;
import com.mojang.datafixers.Dynamic;
import java.util.function.Function;
import net.minecraft.world.level.levelgen.feature.configurations.SpringConfiguration;

public class SpringFeature extends Feature<SpringConfiguration> {
    public SpringFeature(final Function<Dynamic<?>, ? extends SpringConfiguration> function) {
        super(function);
    }
    
    @Override
    public boolean place(final LevelAccessor bju, final ChunkGenerator<? extends ChunkGeneratorSettings> bzx, final Random random, final BlockPos fk, final SpringConfiguration chh) {
        if (!chh.validBlocks.contains(bju.getBlockState(fk.above()).getBlock())) {
            return false;
        }
        if (chh.requiresBlockBelow && !chh.validBlocks.contains(bju.getBlockState(fk.below()).getBlock())) {
            return false;
        }
        final BlockState byg7 = bju.getBlockState(fk);
        if (!byg7.isAir() && !chh.validBlocks.contains(byg7.getBlock())) {
            return false;
        }
        int integer8 = 0;
        int integer9 = 0;
        if (chh.validBlocks.contains(bju.getBlockState(fk.west()).getBlock())) {
            ++integer9;
        }
        if (chh.validBlocks.contains(bju.getBlockState(fk.east()).getBlock())) {
            ++integer9;
        }
        if (chh.validBlocks.contains(bju.getBlockState(fk.north()).getBlock())) {
            ++integer9;
        }
        if (chh.validBlocks.contains(bju.getBlockState(fk.south()).getBlock())) {
            ++integer9;
        }
        if (chh.validBlocks.contains(bju.getBlockState(fk.below()).getBlock())) {
            ++integer9;
        }
        int integer10 = 0;
        if (bju.isEmptyBlock(fk.west())) {
            ++integer10;
        }
        if (bju.isEmptyBlock(fk.east())) {
            ++integer10;
        }
        if (bju.isEmptyBlock(fk.north())) {
            ++integer10;
        }
        if (bju.isEmptyBlock(fk.south())) {
            ++integer10;
        }
        if (bju.isEmptyBlock(fk.below())) {
            ++integer10;
        }
        if (integer9 == chh.rockCount && integer10 == chh.holeCount) {
            bju.setBlock(fk, chh.state.createLegacyBlock(), 2);
            bju.getLiquidTicks().scheduleTick(fk, chh.state.getType(), 0);
            ++integer8;
        }
        return integer8 > 0;
    }
}
