package net.minecraft.world.level.levelgen.feature;

import net.minecraft.world.level.levelgen.feature.configurations.TreeConfiguration;
import java.util.Optional;
import net.minecraft.world.level.levelgen.structure.BoundingBox;
import java.util.Set;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.LevelSimulatedRW;
import com.mojang.datafixers.Dynamic;
import java.util.function.Function;
import net.minecraft.world.level.levelgen.feature.configurations.SmallTreeConfiguration;

public class TreeFeature extends AbstractSmallTreeFeature<SmallTreeConfiguration> {
    public TreeFeature(final Function<Dynamic<?>, ? extends SmallTreeConfiguration> function) {
        super(function);
    }
    
    public boolean doPlace(final LevelSimulatedRW bjy, final Random random, final BlockPos fk, final Set<BlockPos> set4, final Set<BlockPos> set5, final BoundingBox cky, final SmallTreeConfiguration chf) {
        final int integer9 = chf.baseHeight + random.nextInt(chf.heightRandA + 1) + random.nextInt(chf.heightRandB + 1);
        final int integer10 = (chf.trunkHeight >= 0) ? (chf.trunkHeight + random.nextInt(chf.trunkHeightRandom + 1)) : (integer9 - (chf.foliageHeight + random.nextInt(chf.foliageHeightRandom + 1)));
        final int integer11 = chf.foliagePlacer.foliageRadius(random, integer10, integer9, chf);
        final Optional<BlockPos> optional12 = this.getProjectedOrigin(bjy, integer9, integer10, integer11, fk, chf);
        if (!optional12.isPresent()) {
            return false;
        }
        final BlockPos fk2 = optional12.get();
        this.setDirtAt(bjy, fk2.below());
        chf.foliagePlacer.createFoliage(bjy, random, chf, integer9, integer10, integer11, fk2, set5);
        this.placeTrunk(bjy, random, integer9, fk2, chf.trunkTopOffset + random.nextInt(chf.trunkTopOffsetRandom + 1), set4, cky, chf);
        return true;
    }
}
