package net.minecraft.world.level.levelgen.feature;

import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.level.levelgen.structure.BoundingBox;
import net.minecraft.world.level.block.Rotation;
import net.minecraft.world.level.levelgen.feature.structures.StructurePoolElement;
import net.minecraft.world.level.levelgen.structure.PoolElementStructurePiece;
import java.util.Random;
import net.minecraft.world.level.levelgen.feature.structures.JigsawPlacement;
import net.minecraft.world.level.levelgen.feature.configurations.VillageConfiguration;
import net.minecraft.world.level.levelgen.WorldgenRandom;
import net.minecraft.world.level.levelgen.structure.StructurePiece;
import java.util.List;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.levelgen.structure.templatesystem.StructureManager;
import net.minecraft.world.level.chunk.ChunkGenerator;

public class VillagePieces {
    public static void addPieces(final ChunkGenerator<?> bzx, final StructureManager cml, final BlockPos fk, final List<StructurePiece> list, final WorldgenRandom ccc, final VillageConfiguration chj) {
        PlainVillagePools.bootstrap();
        SnowyVillagePools.bootstrap();
        SavannaVillagePools.bootstrap();
        DesertVillagePools.bootstrap();
        TaigaVillagePools.bootstrap();
        JigsawPlacement.addPieces(chj.startPool, chj.size, VillagePiece::new, bzx, cml, fk, list, ccc);
    }
    
    public static class VillagePiece extends PoolElementStructurePiece {
        public VillagePiece(final StructureManager cml, final StructurePoolElement cih, final BlockPos fk, final int integer, final Rotation btr, final BoundingBox cky) {
            super(StructurePieceType.VILLAGE, cml, cih, fk, integer, btr, cky);
        }
        
        public VillagePiece(final StructureManager cml, final CompoundTag jt) {
            super(cml, jt, StructurePieceType.VILLAGE);
        }
    }
}
