package net.minecraft.world.level.levelgen.feature.structures;

import com.google.common.collect.Maps;
import net.minecraft.resources.ResourceLocation;
import java.util.Map;

public class StructureTemplatePools {
    private final Map<ResourceLocation, StructureTemplatePool> pools;
    
    public StructureTemplatePools() {
        this.pools = Maps.newHashMap();
        this.register(StructureTemplatePool.EMPTY);
    }
    
    public void register(final StructureTemplatePool cij) {
        this.pools.put(cij.getName(), cij);
    }
    
    public StructureTemplatePool getPool(final ResourceLocation sm) {
        final StructureTemplatePool cij3 = this.pools.get(sm);
        return (cij3 != null) ? cij3 : StructureTemplatePool.INVALID;
    }
}
