package net.minecraft.world.level.levelgen.feature.treedecorators;

import net.minecraft.world.level.block.state.AbstractStateHolder;
import net.minecraft.core.Vec3i;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.properties.BooleanProperty;
import net.minecraft.world.level.LevelWriter;
import net.minecraft.world.level.levelgen.structure.BoundingBox;
import java.util.Set;
import net.minecraft.core.BlockPos;
import java.util.List;
import java.util.Random;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.util.Serializable;

public abstract class TreeDecorator implements Serializable {
    protected final TreeDecoratorType<?> type;
    
    protected TreeDecorator(final TreeDecoratorType<?> cir) {
        this.type = cir;
    }
    
    public abstract void place(final LevelAccessor bju, final Random random, final List<BlockPos> list3, final List<BlockPos> list4, final Set<BlockPos> set, final BoundingBox cky);
    
    protected void placeVine(final LevelWriter bkb, final BlockPos fk, final BooleanProperty byy, final Set<BlockPos> set, final BoundingBox cky) {
        this.setBlock(bkb, fk, ((AbstractStateHolder<O, BlockState>)Blocks.VINE.defaultBlockState()).<Comparable, Boolean>setValue((Property<Comparable>)byy, true), set, cky);
    }
    
    protected void setBlock(final LevelWriter bkb, final BlockPos fk, final BlockState byg, final Set<BlockPos> set, final BoundingBox cky) {
        bkb.setBlock(fk, byg, 19);
        set.add(fk);
        cky.expand(new BoundingBox(fk, fk));
    }
}
