package net.minecraft.world.level.levelgen.placement;

import net.minecraft.world.level.levelgen.feature.configurations.DecoratorConfiguration;
import net.minecraft.world.level.levelgen.Heightmap;
import java.util.stream.IntStream;
import java.util.stream.Stream;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.levelgen.ChunkGeneratorSettings;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;
import com.mojang.datafixers.Dynamic;
import java.util.function.Function;

public class TopSolidHeightMapRangeDecorator extends FeatureDecorator<RangeDecoratorConfiguration> {
    public TopSolidHeightMapRangeDecorator(final Function<Dynamic<?>, ? extends RangeDecoratorConfiguration> function) {
        super(function);
    }
    
    @Override
    public Stream<BlockPos> getPositions(final LevelAccessor bju, final ChunkGenerator<? extends ChunkGeneratorSettings> bzx, final Random random, final RangeDecoratorConfiguration ckk, final BlockPos fk) {
        final int integer7 = random.nextInt(ckk.max - ckk.min) + ckk.min;
        final int integer8;
        final int integer9;
        final int integer10;
        return IntStream.range(0, integer7).<BlockPos>mapToObj(integer -> {
            integer8 = random.nextInt(16) + fk.getX();
            integer9 = random.nextInt(16) + fk.getZ();
            integer10 = bju.getHeight(Heightmap.Types.OCEAN_FLOOR_WG, integer8, integer9);
            return new BlockPos(integer8, integer10, integer9);
        });
    }
}
