package net.minecraft.world.level.levelgen.placement.nether;

import net.minecraft.world.level.levelgen.feature.configurations.DecoratorConfiguration;
import java.util.stream.IntStream;
import java.util.stream.Stream;
import net.minecraft.core.BlockPos;
import java.util.Random;
import com.mojang.datafixers.Dynamic;
import java.util.function.Function;
import net.minecraft.world.level.levelgen.feature.configurations.CountRangeDecoratorConfiguration;
import net.minecraft.world.level.levelgen.placement.SimpleFeatureDecorator;

public class RandomCountRangeDecorator extends SimpleFeatureDecorator<CountRangeDecoratorConfiguration> {
    public RandomCountRangeDecorator(final Function<Dynamic<?>, ? extends CountRangeDecoratorConfiguration> function) {
        super(function);
    }
    
    public Stream<BlockPos> place(final Random random, final CountRangeDecoratorConfiguration cgf, final BlockPos fk) {
        final int integer5 = random.nextInt(Math.max(cgf.count, 1));
        final int integer6;
        final int integer7;
        final int integer8;
        return IntStream.range(0, integer5).<BlockPos>mapToObj(integer -> {
            integer6 = random.nextInt(16) + fk.getX();
            integer7 = random.nextInt(16) + fk.getZ();
            integer8 = random.nextInt(cgf.maximum - cgf.topOffset) + cgf.bottomOffset;
            return new BlockPos(integer6, integer8, integer7);
        });
    }
}
