package net.minecraft.world.level.levelgen.surfacebuilders;

import net.minecraft.world.level.block.Blocks;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.biome.Biome;
import net.minecraft.world.level.chunk.ChunkAccess;
import java.util.Random;
import com.mojang.datafixers.Dynamic;
import java.util.function.Function;

public class DefaultSurfaceBuilder extends SurfaceBuilder<SurfaceBuilderBaseConfiguration> {
    public DefaultSurfaceBuilder(final Function<Dynamic<?>, ? extends SurfaceBuilderBaseConfiguration> function) {
        super(function);
    }
    
    @Override
    public void apply(final Random random, final ChunkAccess bzv, final Biome bkq, final int integer4, final int integer5, final int integer6, final double double7, final BlockState byg8, final BlockState byg9, final int integer10, final long long11, final SurfaceBuilderBaseConfiguration cne) {
        this.apply(random, bzv, bkq, integer4, integer5, integer6, double7, byg8, byg9, cne.getTopMaterial(), cne.getUnderMaterial(), cne.getUnderwaterMaterial(), integer10);
    }
    
    protected void apply(final Random random, final ChunkAccess bzv, final Biome bkq, final int integer4, final int integer5, final int integer6, final double double7, final BlockState byg8, final BlockState byg9, final BlockState byg10, final BlockState byg11, final BlockState byg12, final int integer13) {
        BlockState byg13 = byg10;
        BlockState byg14 = byg11;
        final BlockPos.MutableBlockPos a18 = new BlockPos.MutableBlockPos();
        int integer14 = -1;
        final int integer15 = (int)(double7 / 3.0 + 3.0 + random.nextDouble() * 0.25);
        final int integer16 = integer4 & 0xF;
        final int integer17 = integer5 & 0xF;
        for (int integer18 = integer6; integer18 >= 0; --integer18) {
            a18.set(integer16, integer18, integer17);
            final BlockState byg15 = bzv.getBlockState(a18);
            if (byg15.isAir()) {
                integer14 = -1;
            }
            else if (byg15.getBlock() == byg8.getBlock()) {
                if (integer14 == -1) {
                    if (integer15 <= 0) {
                        byg13 = Blocks.AIR.defaultBlockState();
                        byg14 = byg8;
                    }
                    else if (integer18 >= integer13 - 4 && integer18 <= integer13 + 1) {
                        byg13 = byg10;
                        byg14 = byg11;
                    }
                    if (integer18 < integer13 && (byg13 == null || byg13.isAir())) {
                        if (bkq.getTemperature(a18.set(integer4, integer18, integer5)) < 0.15f) {
                            byg13 = Blocks.ICE.defaultBlockState();
                        }
                        else {
                            byg13 = byg9;
                        }
                        a18.set(integer16, integer18, integer17);
                    }
                    integer14 = integer15;
                    if (integer18 >= integer13 - 1) {
                        bzv.setBlockState(a18, byg13, false);
                    }
                    else if (integer18 < integer13 - 7 - integer15) {
                        byg13 = Blocks.AIR.defaultBlockState();
                        byg14 = byg8;
                        bzv.setBlockState(a18, byg12, false);
                    }
                    else {
                        bzv.setBlockState(a18, byg14, false);
                    }
                }
                else if (integer14 > 0) {
                    --integer14;
                    bzv.setBlockState(a18, byg14, false);
                    if (integer14 == 0 && byg14.getBlock() == Blocks.SAND && integer15 > 1) {
                        integer14 = random.nextInt(4) + Math.max(0, integer18 - 63);
                        byg14 = ((byg14.getBlock() == Blocks.RED_SAND) ? Blocks.RED_SANDSTONE.defaultBlockState() : Blocks.SANDSTONE.defaultBlockState());
                    }
                }
            }
        }
    }
}
