package net.minecraft.world.level.levelgen.surfacebuilders;

import net.minecraft.world.level.block.Blocks;
import java.util.function.Function;
import com.mojang.datafixers.Dynamic;
import net.minecraft.world.level.block.state.BlockState;

public class SurfaceBuilderBaseConfiguration implements SurfaceBuilderConfiguration {
    private final BlockState topMaterial;
    private final BlockState underMaterial;
    private final BlockState underwaterMaterial;
    
    public SurfaceBuilderBaseConfiguration(final BlockState byg1, final BlockState byg2, final BlockState byg3) {
        this.topMaterial = byg1;
        this.underMaterial = byg2;
        this.underwaterMaterial = byg3;
    }
    
    @Override
    public BlockState getTopMaterial() {
        return this.topMaterial;
    }
    
    @Override
    public BlockState getUnderMaterial() {
        return this.underMaterial;
    }
    
    public BlockState getUnderwaterMaterial() {
        return this.underwaterMaterial;
    }
    
    public static SurfaceBuilderBaseConfiguration deserialize(final Dynamic<?> dynamic) {
        final BlockState byg2 = dynamic.get("top_material").map((Function)BlockState::deserialize).orElse(Blocks.AIR.defaultBlockState());
        final BlockState byg3 = dynamic.get("under_material").map((Function)BlockState::deserialize).orElse(Blocks.AIR.defaultBlockState());
        final BlockState byg4 = dynamic.get("underwater_material").map((Function)BlockState::deserialize).orElse(Blocks.AIR.defaultBlockState());
        return new SurfaceBuilderBaseConfiguration(byg2, byg3, byg4);
    }
}
