package net.minecraft.world.level.material;

import net.minecraft.world.phys.shapes.Shapes;
import net.minecraft.world.phys.shapes.VoxelShape;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.phys.Vec3;
import net.minecraft.core.Direction;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.Item;

public class EmptyFluid extends Fluid {
    @Override
    public Item getBucket() {
        return Items.AIR;
    }
    
    public boolean canBeReplacedWith(final FluidState cog, final BlockGetter bjd, final BlockPos fk, final Fluid cof, final Direction fp) {
        return true;
    }
    
    public Vec3 getFlow(final BlockGetter bjd, final BlockPos fk, final FluidState cog) {
        return Vec3.ZERO;
    }
    
    @Override
    public int getTickDelay(final LevelReader bjw) {
        return 0;
    }
    
    @Override
    protected boolean isEmpty() {
        return true;
    }
    
    @Override
    protected float getExplosionResistance() {
        return 0.0f;
    }
    
    @Override
    public float getHeight(final FluidState cog, final BlockGetter bjd, final BlockPos fk) {
        return 0.0f;
    }
    
    @Override
    public float getOwnHeight(final FluidState cog) {
        return 0.0f;
    }
    
    @Override
    protected BlockState createLegacyBlock(final FluidState cog) {
        return Blocks.AIR.defaultBlockState();
    }
    
    @Override
    public boolean isSource(final FluidState cog) {
        return false;
    }
    
    @Override
    public int getAmount(final FluidState cog) {
        return 0;
    }
    
    @Override
    public VoxelShape getShape(final FluidState cog, final BlockGetter bjd, final BlockPos fk) {
        return Shapes.empty();
    }
}
