package net.minecraft.world.level.pathfinder;

import net.minecraft.network.FriendlyByteBuf;

public class Target extends Node {
    private float bestHeuristic;
    private Node bestNode;
    private boolean reached;
    
    public Target(final Node cql) {
        super(cql.x, cql.y, cql.z);
        this.bestHeuristic = Float.MAX_VALUE;
    }
    
    public Target(final int integer1, final int integer2, final int integer3) {
        super(integer1, integer2, integer3);
        this.bestHeuristic = Float.MAX_VALUE;
    }
    
    public void updateBest(final float float1, final Node cql) {
        if (float1 < this.bestHeuristic) {
            this.bestHeuristic = float1;
            this.bestNode = cql;
        }
    }
    
    public Node getBestNode() {
        return this.bestNode;
    }
    
    public void setReached() {
        this.reached = true;
    }
    
    public boolean isReached() {
        return this.reached;
    }
    
    public static Target createFromStream(final FriendlyByteBuf kv) {
        final Target cqr2 = new Target(kv.readInt(), kv.readInt(), kv.readInt());
        cqr2.walkedDistance = kv.readFloat();
        cqr2.costMalus = kv.readFloat();
        cqr2.closed = kv.readBoolean();
        cqr2.type = BlockPathTypes.values()[kv.readInt()];
        cqr2.f = kv.readFloat();
        return cqr2;
    }
}
