package net.minecraft.world.level.storage.loot.entries;

import java.util.Objects;
import java.util.function.Consumer;
import net.minecraft.world.level.storage.loot.LootContext;

@FunctionalInterface
interface ComposableEntryContainer {
    public static final ComposableEntryContainer ALWAYS_FALSE = (cru, consumer) -> false;
    public static final ComposableEntryContainer ALWAYS_TRUE = (cru, consumer) -> true;
    
    boolean expand(final LootContext cru, final Consumer<LootPoolEntry> consumer);
    
    default ComposableEntryContainer and(final ComposableEntryContainer csf) {
        Objects.<ComposableEntryContainer>requireNonNull(csf);
        return (cru, consumer) -> this.expand(cru, consumer) && csf.expand(cru, consumer);
    }
    
    default ComposableEntryContainer or(final ComposableEntryContainer csf) {
        Objects.<ComposableEntryContainer>requireNonNull(csf);
        return (cru, consumer) -> this.expand(cru, consumer) || csf.expand(cru, consumer);
    }
}
