package net.minecraft.world.phys;

import java.util.Objects;

public class PosAndRot {
    private final Vec3 pos;
    private final float xRot;
    private final float yRot;
    
    public PosAndRot(final Vec3 cvi, final float float2, final float float3) {
        this.pos = cvi;
        this.xRot = float2;
        this.yRot = float3;
    }
    
    public Vec3 pos() {
        return this.pos;
    }
    
    public float xRot() {
        return this.xRot;
    }
    
    public float yRot() {
        return this.yRot;
    }
    
    @Override
    public boolean equals(final Object object) {
        if (this == object) {
            return true;
        }
        if (object == null || this.getClass() != object.getClass()) {
            return false;
        }
        final PosAndRot cvg3 = (PosAndRot)object;
        return Float.compare(cvg3.xRot, this.xRot) == 0 && Float.compare(cvg3.yRot, this.yRot) == 0 && Objects.equals(this.pos, cvg3.pos);
    }
    
    @Override
    public int hashCode() {
        return Objects.hash(this.pos, this.xRot, this.yRot);
    }
    
    @Override
    public String toString() {
        return "PosAndRot[" + this.pos + " (" + this.xRot + ", " + this.yRot + ")]";
    }
}
